PROGRAM XOpa;

{programmiert von Axel Drfler}

{$opt q}

USES Intuition,Gadtools,Exec,ExecSupport,Graphics;

{$incl "exec/execbase.h","own/Menu.h","workbench/startup.h","icon.lib","dos.lib","wb.lib","expansion.lib","asl.lib","amigaguide.lib"}

CONST   _VERSION = "1.03 (3.10.1994)";
        _ID = "$VER: XOpa 1.03 (3.10.94)";

        STRUCT_BYTE    = 1;
        STRUCT_UBYTE   = 2;
        STRUCT_WORD    = 3;
        STRUCT_UWORD   = 4;
        STRUCT_LONG    = 5;
        STRUCT_FLGBYTE = 6;
        STRUCT_FLGWORD = 7;
        STRUCT_FLGLONG = 8;
        STRUCT_PTR     = 9;
        STRUCT_BPTR    = 10;
        STRUCT_STRUCT  = 11;
        STRUCT_PSTRUCT = 12;
        STRUCT_STRING  = 13;

TYPE    AppString   = String[256];
        MousePointerTyp = Array[1..18] of Long;      {Mauszeigerdaten (fr OS2.0)}

        Typen       = Array[0..16] of String[15];
        p_Byte      = ^Byte;

        p_LibTyp    = ^LibTyp;                       {Strukturmodus: siehe AddLibTyp}
        LibTyp      = Record
                        Node    :Node;
                        Name    :String;
                        Struct  :String;
                      End;
        p_StructTyp = ^StructTyp;                    {Eintrag innerhalb einer Struktur}
        StructTyp   = Record
                        Node    :Node;
                        Name    :String;
                        Typ     :String;
                      End;
        p_Struct    = ^Struct;                       {Strukturdefinition im Strukturmodus}
        Struct      = Record
                        Node    :Node;
                        Name    :String;
                        Length  :Long;
                        Entrys  :List;
                      End;
        p_Merker    = ^Merker;                       {Merkeintrge fr das Zurck-Gadget im Strukturmodus}
        Merker      = Record
                        Node    :Node;
                        Struct  :^Struct;
                        Address :Ptr;
        Top   :Long;
                      End;
        p_ListEntry = ^ListEntry;                    {Eintrag der eigentlichen angezeigten Liste}
        ListEntry   = Record
                        Node    :Node;
                        Name    :AppString;
                        ObjName :AppString;
                        Address :Ptr;
                      End;

VAR     Win     :^Window;
        Msg     :^IntuiMessage;
        Ende    :Boolean;
        PubScr  :^Screen;
        dum     :Long;
        VInfo   :Ptr;
        Men     :^Menu;
        GadList :^Gadget;
        LstGad  :^Gadget;
        Tatter  :TextAttr;
        TatXSize:Word;
        AktNode :^ListEntry;
        Liste   :List;                      {Anzeigeliste}
        Structs :List;                      {Liste der Strukturen}
        Gads    :Array[1..8] of p_Gadget;
        Fragen  :Boolean;
        TWinRel :Boolean;

        NodeTypen       :Array[1..5] of p_Struct;
        MerkListe       :List;
        Libraries       :List;
        StructAddress   :Ptr;            {Strukturmodus: aktuelle Adresse}
        StructName      :String[129];    {Name der Strukturdefinitionsdatei}
        AktStruct       :^Struct;
        AktStructTyp    :^StructTyp;
        SleepReq        :^Requester;     {<- fr SetWaitPointer()}
        MPointerDat     :^MousePointerTyp;
        DispMode        :Integer;                    {<- aktuell dargestellter Modus}
        TitleTexts      :^Array[1..34] of String;
        ActiveGads      :Array[1..14] of Byte;
        StatusText      :String;        {<- Inhalt der Statuszeile}
        WinTitle        :String;
        ScrPtr          :^Screen;       {<- Screenzeiger fr GetWindowList}
        WinTask         :^Task;         {<- Zeiger auf Task fr ""}


FUNCTION Dez2Hex(d0 :Long) : Str;  EXTERNAL;    {<-liegt als Assembler-Source und linkbare Objekt-Datei bei}


{FUNCTION Dez2Hex(dezimal :Long) : String;

VAR     i,zahl  :Integer;
        Digits  :String[18];                    {<- die gleiche Funktion, im Pascal-Source (1/10 der Geschwindigkeit der Assemblerroutine)}
        Hex     :String[10];

BEGIN
  Hex:='00000000';  Digits:='0123456789abcdef';
  For i:=8 downto 1 Do Begin
    zahl:=dezimal and 15;
    If dezimal>=0 Then dezimal:=dezimal div 16
                  Else dezimal:=(dezimal and $7fffffff) div 16 +$8000000;
    Hex[i]:=Digits[zahl+1];
  End;
  Dez2Hex:=Hex;
END;}


FUNCTION BCPLString(BCPL :p_Byte) : AppString;

VAR     s       :Str;
        Txt     :AppString;

BEGIN                                           {wandelt BSTR-Strings in normale Strings um}
  s:=Str(Long(BCPL)+1);
  Txt:=s;
  Txt[ord(BCPL^)+1]:=chr(0);
  BCPLString:=Txt;
END;


FUNCTION CountGadToolGads : Long;

VAR     Gad     :^Gadget;
        Count   :Long;

BEGIN                                           {Zhlt GadTools-Gadgets fr Grennderung, s. HandleIDCMP}
  Gad:=Win^.FirstGadget;
  Count:=0;
  While Gad<>Nil Do Begin
    If (Gad^.GadgetType and 256)>0 Then
      Inc(Count);
    Gad:=Gad^.NextGadget;
  End;
  CountGadToolGads:=Count;
END;


PROCEDURE SetWaitPointer(Wait :Boolean);

VAR     Tags    :Array[1..2] of TagItem;

BEGIN                                           {setzt den Wartezeiger je nach OS-Version}
  If (Wait) and (Not Ende) Then Begin
    InitRequester(SleepReq);
    Ende:=Request(SleepReq,Win);
    If IntuitionBase^.LibNode.lib_Version>=39 Then Begin
      Tags[1]:=TagItem(WA_BusyPointer,1);
      Tags[2].ti_Tag:=TAG_DONE;
      SetWindowPointerA(Win,^Tags);
    End Else
      SetPointer(Win, MPointerDat, 16,16, -6,0);
  End Else If Not Wait Then Begin
    ClearPointer(Win);
    If Ende Then
      EndRequest(SleepReq,Win);
    Ende:=false;
  End;
END;


FUNCTION TLn(Txt: String) : Long;
                                                {berechnet die Lnge eines Textes mit dem Screen-Font}
BEGIN
  TLn:=TextLength(^PubScr^.RastPort,Txt,Length(Txt));
END;


PROCEDURE FreeNodeList;

VAR     SavNode :^ListEntry;                    {entfernt die Anzeigeliste aus dem Speicher}

BEGIN
  AktNode:=p_ListEntry(Liste.lh_Head);
  If Liste.lh_Head<>^Liste.lh_Tail Then
    While AktNode^.Node.ln_Succ<>Nil Do Begin
      SavNode:=p_ListEntry(AktNode^.Node.ln_Succ);
      Dispose(AktNode);
      AktNode:=SavNode;
    End;
  NewList(^Liste);
END;


PROCEDURE FreeMerkListe;

VAR     SavMerk :^Merker;
        AktMerk :^Merker;
                                                {entfernt die Merkerliste im Strukturmodus}
BEGIN
  AktMerk:=p_Merker(MerkListe.lh_Head);
  If MerkListe.lh_Head<>^MerkListe.lh_Tail Then
    While AktMerk^.Node.ln_Succ<>Nil Do Begin
      SavMerk:=p_Merker(AktMerk^.Node.ln_Succ);
      Dispose(AktMerk);
      AktMerk:=SavMerk;
    End;
  NewList(^MerkListe);
END;


PROCEDURE ErrorRequest(Meldung :AppString;Ende :Boolean);

VAR     EasyReq :EasyStruct;
                                                {Zeigt Fehlermeldungen an}
BEGIN
  For dum:=1 to Length(Meldung) Do
    If Meldung[dum]='|' Then Meldung[dum]:=Chr(10);
  EasyReq:=EasyStruct(SizeOf(EasyStruct),0,'XOpa-Meldung',Meldung,'Ok');
  dum:=EasyRequestArgs(Win,^EasyReq,Nil,Nil);
  If Ende Then
    Halt(0);
END;


FUNCTION Frage(Meldung :AppString) : Boolean;

VAR     EasyReq :EasyStruct;
                                                {Fragt`ne Frage}
BEGIN
  For dum:=1 to Length(Meldung) Do
    If Meldung[dum]='|' Then Meldung[dum]:=Chr(10);
  EasyReq:=EasyStruct(SizeOf(EasyStruct),0,'XOpa-Meldung',Meldung,'Ok|Abbrechen');
  dum:=EasyRequestArgs(Win,^EasyReq,Nil,Nil);
  If dum=1 Then
    Frage:=true
  Else
    Frage:=false;
END;


FUNCTION DecryptHex(Txt :String) : Long;

VAR   Hex     :Array[0..16] of Char;
      i,j     :Integer;
      Zahl    :Long;
                                                {Wandelt Hexadezimal- in Dezimalzahlen um}
BEGIN
  Txt:=Copy(Txt,1,8);
  Hex:='0123456789ABCDEF';
  Zahl:=0;
  For i:=Length(Txt) downto 1 Do
    For j:=0 to 15 Do
      If Upcase(Txt[i])=Hex[j] Then
        Zahl:=Zahl+(j shl ((Length(Txt)-i)*4));
  DecryptHex:=Zahl;
END;


PROCEDURE FullName(Sohn :BPTR;VAR FName :AppString);

VAR     Vater   :BPTR;
        fib     :^FileInfoBlock;
        stat    :Integer;
                                                {Gibt den ganzen Pfadnamen des bergebenen Locks zurck}
BEGIN
  Vater:=ParentDir(Sohn);
  If Vater<>0 Then
    Fullname(Vater,FName);
  fib:=Ptr(Alloc_Mem(SizeOf(FileInfoBlock),0));
  stat:=Examine(Sohn, fib);
  If stat<>0 Then
    FName:=FName+fib^.fib_Filename;
  If Vater=0 Then
    FName:=FName+':'
  Else
    FName:=FName+'/';
  Free_Mem(Long(fib), SizeOf(FileInfoBlock));
END;


FUNCTION TaskNam(TaskFnd :p_Task) : AppString;

VAR     Procs   :^Process;
        ComLInt :^CommandLineInterface;
        CliNam  :AppString;
        CliNum  :Integer;
                                                {Gibt den Tasknamen zurck, da dieser oft gut versteckt ist}
BEGIN
  CliNam:='';
  If TaskFnd=Nil Then Begin
    TaskNam:=CliNam;
    Exit;
  End;
  If TaskFnd^.tc_Node.ln_Type=13 Then Begin
    Procs:=^TaskFnd^;
    If Procs^.pr_TaskNum=0 Then
      CliNam:=Procs^.pr_Task.tc_Node.ln_Name
    Else Begin
      CliNum:=Procs^.pr_TaskNum;
      ComLInt:=Ptr(Procs^.pr_CLI shl 2);
      CliNam:=BCPLString(Ptr(ComLInt^.cli_CommandName shl 2));
      CliNam:='CLI('+IntStr(CliNum)+'):'+CliNam;
    End;
  End Else Begin
    CliNam:=TaskFnd^.tc_Node.ln_Name;
  End;
  TaskNam:=CliNam;
END;


FUNCTION FormText(Txt :AppString;MaxChar :Integer;Links :Boolean) : AppString;

VAR    Spaces  :AppString;
                                                {formatiert die Textausgabe}
BEGIN
  Spaces:='                                                        ';
  If Length(Txt)>MaxChar Then
    Txt:=Copy(Txt, 1,MaxChar)
  Else Begin
    If Links Then
      Txt:=Txt+Copy(Spaces,1,MaxChar-Length(Txt))
    Else
      Txt:=Copy(Spaces,1,MaxChar-Length(Txt))+Txt;
  End;
  FormText:=Txt;
END;


PROCEDURE AddText(Txt :AppString;Center :Boolean);
                                                {hngt eine Zeile in der Anzeigeliste an (auch zentriert)}
BEGIN
  dum:=(LstGad^.Width-16) Div (2*TatXSize)+Length(Txt) shr 1;
  New(AktNode);
  If Center Then
    AktNode^.Name:=FormText(Txt,dum,false)
  Else
    AktNode^.Name:=Txt;
  AktNode^.Address:=Ptr(0);
  AktNode^.Node.ln_Name:=AktNode^.Name;  AddTail(^Liste, ^AktNode^.Node);
END;


PROCEDURE AddFlagText(Txt :AppString;Offset :Long);

VAR     Spaces  :AppString;
                                                {hngt einen Text an eine bestehende Zeile}
BEGIN                                           {und fgt gegenenfalls eine neue ein}
  Spaces:='                              ';
  If (Length(AktNode^.Name)+Length(Txt))>((LstGad^.Width-20) Div (TatXSize)) Then Begin
    AktNode^.Node.ln_Name:=AktNode^.Name;
    AddTail(^Liste, ^AktNode^.Node);
    New(AktNode);
    AktNode^.Name:=Copy(Spaces,1,Offset);
    AktNode^.Address:=Ptr(0);
  End;
  AktNode^.Name:=AktNode^.Name+Txt+' + ';
END;


PROCEDURE DrawStatus;

VAR     IText   :IntuiText;
                                                {zeigt die Statuszeile an (unter dem ListView-Gadget)}
BEGIN
  SetAPen(Win^.RPort, 0);
  RectFill(Win^.RPort, 10,LstGad^.TopEdge+2+LstGad^.Height, Win^.Width-11,LstGad^.TopEdge+LstGad^.Height+Tatter.ta_YSize+1);
  If Length(StatusText)>(LstGad^.Width-8) Div TatXSize Then
    StatusText:=Copy(StatusText,1,(LstGad^.Width-8) Div TatXSize);
  IText:=IntuiText(1,0,1,0,0,^Tatter,StatusText,Nil);
  PrintIText(Win^.RPort,^IText,12,2+LstGad^.TopEdge+LstGad^.Height);
END;


FUNCTION RemoveWindows(TaskPtr :p_Task;Delete :Boolean) : Boolean;

VAR     IntBas  :p_IntuitionBase;
        ILock   :Long;
        ScrPtr  :^Screen;
        WinPtr  :^Window;
        WinSave :Ptr;
                                                {schliet alle Fenster eines Tasks oder Screens}
BEGIN
  RemoveWindows:=false;
  IntBas:=IntuitionBase;
  ILock:=LockIBase(0);
  ScrPtr:=IntBas^.FirstScreen;
  While ScrPtr<>Nil Do Begin
    WinPtr:=ScrPtr^.FirstWindow;
    While WinPtr<>Nil Do Begin
      WinSave:=WinPtr^.NextWindow;
      If (TaskPtr=WinPtr^.UserPort^.mp_SigTask) Then Begin
        If Delete Then Begin
          WinPtr^.UserPort:=Nil;
          ModifyIDCMP(WinPtr, 0);
          CloseWindow(WinPtr);
        End Else
          RemoveWindows:=true;
      End;
      WinPtr:=WinSave;
    End;
    ScrPtr:=ScrPtr^.NextScreen;
  End;
  UnlockIBase(ILock);
  If Delete Then
    RemTask(TaskPtr);
END;


PROCEDURE ListeDrucken;

VAR     prt     :Text;
        myNode  :^ListEntry;                    {Gibt die aktuelle Liste auf dem Drucker aus}

  FUNCTION Probleme : Boolean;

  VAR     EasyReq :EasyStruct;

  BEGIN
    EasyReq:=EasyStruct(SizeOf(EasyStruct),0,'XOpa-Meldung','Probleme mit dem Drucker.','Nochmal|Abbrechen');
    dum:=EasyRequestArgs(Win,^EasyReq,Nil,Nil);
    If dum=0 Then
      Probleme:=true
    Else
      Probleme:=false;
  END;

BEGIN
  Rewrite(prt,'prt:');
  If (IOResult<>0) and (Probleme) Then
    Exit;
  Writeln(prt,chr(155),'1m',TitleTexts^[DispMode],chr(155),'0m');
  Writeln(prt);  dum:=0;
  myNode:=p_ListEntry(Liste.lh_Head);
  Repeat
    Writeln(prt,myNode^.Name);
    myNode:=p_ListEntry(myNode^.Node.ln_Succ);
    If (IOResult<>0) and (IOResult=11132) Then
      dum:=142;
  Until (myNode^.Node.ln_Succ=Nil) or ((dum=142) and (Probleme));
  Close(prt);
END;


PROCEDURE FlushLibraries;

VAR     Speicher        :Ptr;
                                                {schmeit unbenutzte Objekte aus dem Speicher (Systemfunktion)}
BEGIN
  Speicher:=Nil;
  Speicher:=AllocMem(AvailMem(MEMF_TOTAL)+42,0);
END;


PROCEDURE AddFont;

VAR     Tags    :Array[1..10] of TagItem;
        Req     :^FontRequester;
                                                {hngt Fonts an die Fontliste an}
BEGIN
  Tags[1]:=TagItem(ASLFO_Window       ,Long(Win));
  Tags[2]:=TagItem(ASLFO_SleepWindow  ,Long(true));
  Tags[3]:=TagItem(ASLFO_TitleText    ,0);  Tags[3].ti_Data:='XOpa-Zeichensatzwahl';
  Tags[4].ti_Tag:=TAG_DONE;
  Req:=AllocAslRequest(ASL_FontRequest,^Tags);
  If Req<>Nil Then Begin
    If AslRequest(Req,Nil) Then;
    FreeAslRequest(Req);
  End;
END;


PROCEDURE AddScreen;

VAR     WinReq  :^Window;
        MsgReq  :^IntuiMessage;
        GadLst  :^Gadget;
        NGad    :Array[1..4] of NewGadget;
        Gad,FGad:^Gadget;
        SGad    :^Gadget;
        Req     :^ScreenModeRequester;
        Tags    :Array[1..13] of TagItem;
        WinTags :Array[1..10] of TagItem;
        SInfo   :^StringInfo;
        Txt     :AppString;
        WTitle  :AppString;
        ok      :Boolean;
        SWidth  :Integer;
        SHeight :Integer;
        SOScan  :Integer;
        DispID  :Long;
        SDepth  :Integer;
                                                {ffnet einen Public-Screen}
BEGIN
  SetWaitPointer(true);
  FGad:=CreateContext(^GadLst);
  If FGad=Nil Then
    ErrorRequest('Fehler bei CreateContext.',true);
  WTitle:='XOpa-Bildschirm ffnen';
  WinTags[1]:=TagItem(WA_Width,       TLn('Modus...Name:Zurck')+166);
  WinTags[2]:=TagItem(WA_Height,      PubScr^.BarHeight+2*PubScr^.Font^.ta_YSize+21);
  WinTags[3]:=TagItem(WA_IDCMP,       IDCMP_GADGETUP or IDCMP_CLOSEWINDOW);
  WinTags[4]:=TagItem(WA_Flags,       WFLG_DEPTHGADGET or WFLG_DRAGBAR or WFLG_ACTIVATE or WFLG_CLOSEGADGET);
  WinTags[5]:=TagItem(WA_Title,       Long(^WTitle));
  WinTags[6]:=TagItem(WA_Gadgets,     Long(FGad));
  WinTags[7]:=TagItem(WA_Left,        Win^.LeftEdge+Win^.Width shr 1-WinTags[1].ti_Data shr 1);
  WinTags[8]:=TagItem(WA_Top,         Win^.TopEdge+Win^.Height shr 1-WinTags[2].ti_Data shr 1);
  WinTags[9].ti_Tag:=TAG_DONE;
  NGad[1]:=NewGadget(16+TLn('Name:'),PubScr^.BarHeight+4,WinTags[1].ti_Data-58-TLn('Name:Modus...'),PubScr^.Font^.ta_YSize+4,'Name:',PubScr^.Font,1,0,VInfo,Nil);
  NGad[2]:=NewGadget(NGad[1].ng_Width+NGad[1].ng_LeftEdge+4,PubScr^.BarHeight+4,TLn('Modus...')+30,PubScr^.Font^.ta_YSize+4,'Modus...',PubScr^.Font,2,PLACETEXT_IN,VInfo,Nil);
  NGad[3]:=NewGadget(8,PubScr^.BarHeight+13+PubScr^.Font^.ta_YSize,TLn('Zurck')+50,PubScr^.Font^.ta_YSize+3,'Ok',PubScr^.Font,3,0,VInfo,Nil);
  NGad[4]:=NewGadget(WinTags[1].ti_Data-58-TLn('Zurck'),PubScr^.BarHeight+13+PubScr^.Font^.ta_YSize,TLn('Zurck')+50,PubScr^.Font^.ta_YSize+3,'Zurck',PubScr^.Font,4,0,VInfo,Nil);
  SGad:=CreateGadgetA(STRING_KIND,FGad,^NGad[1],Nil);
  Tags[1]:=TagItem(GA_Disabled,  Long(AslBase^.lib_Version<38));
  Tags[2].ti_Tag:=TAG_DONE;
  Gad:=CreateGadgetA(BUTTON_KIND,SGad,^NGad[2],^Tags);
  Gad:=CreateGadgetA(BUTTON_KIND,Gad,^NGad[3],Nil);
  Gad:=CreateGadgetA(BUTTON_KIND,Gad,^NGad[4],Nil);
  WinReq:=OpenWindowTagList(Nil, ^WinTags);
  If WinReq=Nil Then
    ErrorRequest('Konnte Fenster nicht ffnen.',true);
  SDepth:=2;  SWidth:=PubScr^.Width;  SHeight:=PubScr^.Height;
  SOScan:=0;  DispID:=GetVPModeID(^PubScr^.ViewPort);
  Tags[1]:=TagItem(ASLSM_Window,      Long(WinReq));
  Tags[2]:=TagItem(ASLSM_SleepWindow, 1);
  Tags[3]:=TagItem(ASLSM_DoDepth,     1);
  Tags[4]:=TagItem(ASLSM_DoOverscanType,1);
  Tags[5]:=TagItem(ASLSM_DoWidth,     1);
  Tags[6]:=TagItem(ASLSM_DoHeight,    1);
  Tags[7]:=TagItem(ASLSM_InitialDisplayID,    DispID);
  Tags[8]:=TagItem(ASLSM_InitialDisplayWidth, SWidth);
  Tags[9]:=TagItem(ASLSM_InitialDisplayHeight,SHeight);
  Tags[10]:=TagItem(ASLSM_InitialDisplayDepth,SDepth);
  Tags[11]:=TagItem(ASLSM_InitialOverscanType,SOScan);
  Tags[12].ti_Tag:=TAG_DONE;
  Req:=Nil;
  If AslBase^.lib_Version>=38 Then
    Req:=AllocAslRequest(ASL_ScreenModeRequest,^Tags);
  ok:=false;
  If ActivateGadget(SGad,WinReq,Nil) Then;
  Repeat
    MsgReq:=Wait_Port(WinReq^.UserPort);
    MsgReq:=Get_Msg(WinReq^.UserPort);
    Case MsgReq^.Class Of
      IDCMP_CLOSEWINDOW: ok:=true;
      IDCMP_GADGETUP: Begin
                        Gad:=MsgReq^.IAddress;
                        If Gad^.GadgetID=2 Then Begin
                          If (Req<>Nil) and (AslRequest(Req,Nil)) Then Begin
                            SDepth:=Req^.sm_DisplayDepth;
                            SWidth:=Req^.sm_DisplayWidth;
                            SHeight:=Req^.sm_DisplayHeight;
                            SOScan:=Req^.sm_OverscanType;
                            DispID:=Req^.sm_DisplayID;
                          End;
                        End;
                        If Gad^.GadgetID=3 Then Begin
                          SInfo:=SGad^.SpecialInfo;
                          Txt:=SInfo^.Buffer;
                          If Txt='' Then
                            Txt:='XOpa-Screen';
                          dum:=Not 0;
                          Tags[1]:=TagItem(SA_Pens,        Long(^dum));
                          Tags[2]:=TagItem(SA_DisplayID,   DispID);
                          Tags[3]:=TagItem(SA_Width,       SWidth);
                          Tags[4]:=TagItem(SA_Height,      SHeight);
                          Tags[5]:=TagItem(SA_Depth,       SDepth);
                          Tags[6]:=TagItem(SA_OverScan,    SOScan);
                          Tags[7]:=TagItem(SA_PubName,     Long(^Txt));
                          Tags[8].ti_Tag:=TAG_DONE;
                          AktNode:=Ptr(OpenScreenTagList(Nil,^Tags));
                          If (AktNode<>Nil) and (PubScreenStatus(^AktNode^,0)=0) Then;
                          AktNode:=Nil;
                        End;
                        If Gad^.GadgetID>2 Then
                          ok:=true;
                      End;
    Else;
    End;
    Reply_Msg(MsgReq);
  Until ok;
  CloseWindow(WinReq);
  FreeGadgets(GadLst);
  If Req<>Nil Then
    FreeAslRequest(Req);
  SetWaitPointer(false);
END;


PROCEDURE AddAssign;

VAR     WinReq  :^Window;
        MsgReq  :^IntuiMessage;
        GadLst  :^Gadget;
        NGad    :Array[1..5] of NewGadget;
        Gad,FGad:^Gadget;
        IGad    :^Gadget;
        SGad    :^Gadget;
        myLock  :BPTR;
        Tags    :Array[1..6] of TagItem;
        WinTags :Array[1..9] of TagItem;
        SInfo   :^StringInfo;
        Txt     :AppString;
        ok      :Boolean;
        FReq    :^FileRequester;
                                                {fgt einen Assign in die Systemliste ein}
BEGIN
  SetWaitPointer(true);
  FGad:=CreateContext(^GadLst);
  If FGad=Nil Then
    ErrorRequest('Probleme mit GadTools',true);
  Txt:='XOpa-Assign fr ein Verzeichnis';
  WinTags[1]:=TagItem(WA_Width,       TLn('Verzeichnis:Whlen...Zurck')+166);
  WinTags[2]:=TagItem(WA_Height,      PubScr^.BarHeight+3*PubScr^.Font^.ta_YSize+29);
  WinTags[3]:=TagItem(WA_IDCMP,       IDCMP_GADGETUP or IDCMP_CLOSEWINDOW);
  WinTags[4]:=TagItem(WA_Flags,       WFLG_DEPTHGADGET or WFLG_DRAGBAR or WFLG_ACTIVATE or WFLG_CLOSEGADGET);
  WinTags[5]:=TagItem(WA_Title,       Long(^Txt));
  WinTags[6]:=TagItem(WA_Gadgets,     Long(FGad));
  WinTags[7]:=TagItem(WA_Left,        Win^.LeftEdge+Win^.Width shr 1-WinTags[1].ti_Data shr 1);
  WinTags[8]:=TagItem(WA_Top,         Win^.TopEdge+Win^.Height shr 1-WinTags[2].ti_Data shr 1);
  WinTags[9].ti_Tag:=TAG_DONE;
  NGad[1]:=NewGadget(16+TLn('Verzeichnis:'),PubScr^.BarHeight+4,WinTags[1].ti_Data-24-TLn('Verzeichnis:'),PubScr^.Font^.ta_YSize+4,'Assign:',PubScr^.Font,1,PLACETEXT_LEFT,VInfo,Nil);
  NGad[2]:=NewGadget(16+TLn('Verzeichnis:'),PubScr^.BarHeight+11+PubScr^.Font^.ta_YSize,
                     WinTags[1].ti_Data-48-TLn('Verzeichnis:Whlen...'),PubScr^.Font^.ta_YSize+4,'Verzeichnis:',PubScr^.Font,2,PLACETEXT_LEFT,VInfo,Nil);
  NGad[3]:=NewGadget(NGad[2].ng_Width+4+NGad[2].ng_LeftEdge,NGad[2].ng_TopEdge,TLn('Whlen...')+20,PubScr^.Font^.ta_YSize+4,'Whlen...',PubScr^.Font,3,0,VInfo,Nil);
  NGad[4]:=NewGadget(8,PubScr^.BarHeight+20+2*PubScr^.Font^.ta_YSize,TLn('Zurck')+50,PubScr^.Font^.ta_YSize+4,'Ok',PubScr^.Font,4,0,VInfo,Nil);
  NGad[5]:=NewGadget(WinTags[1].ti_Data-58-TLn('Zurck'),PubScr^.BarHeight+20+2*PubScr^.Font^.ta_YSize,TLn('Zurck')+50,PubScr^.Font^.ta_YSize+4,'Zurck',PubScr^.Font,5,0,VInfo,Nil);
  IGad:=CreateGadgetA(STRING_KIND,FGad,^NGad[1],Nil);
  SGad:=CreateGadgetA(STRING_KIND,IGad,^NGad[2],Nil);
  Gad:=CreateGadgetA(BUTTON_KIND,SGad,^NGad[3],Nil);
  Gad:=CreateGadgetA(BUTTON_KIND,Gad,^NGad[4],Nil);
  Gad:=CreateGadgetA(BUTTON_KIND,Gad,^NGad[5],Nil);
  WinReq:=OpenWindowTagList(Nil, ^WinTags);
  If WinReq=Nil Then
    ErrorRequest('Konnte Fenster nicht ffnen.',true);
  ok:=false;
  Tags[1]:=TagItem(ASLFR_Window       ,Long(Win));
  Tags[2]:=TagItem(ASLFR_SleepWindow  ,Long(true));
  Tags[3]:=TagItem(ASLFR_TitleText    ,0);  Tags[3].ti_Data:='Verzeichnis auswhlen';
  Tags[4]:=TagItem(ASLFR_InitialHeight,PubScr^.Height-6*PubScr^.BarHeight);
  Tags[5]:=TagItem(ASLFR_DrawersOnly  ,Long(true));
  Tags[6].ti_Tag:=TAG_DONE;
  FReq:=AllocAslRequest(ASL_FileRequest,^Tags);
  If ActivateGadget(IGad,WinReq,Nil) Then;
  Repeat
    MsgReq:=Wait_Port(WinReq^.UserPort);
    MsgReq:=GT_GetIMsg(WinReq^.UserPort);
    Case MsgReq^.Class Of
      IDCMP_CLOSEWINDOW: ok:=true;
      IDCMP_GADGETUP: Begin
                        Gad:=MsgReq^.IAddress;
                        Case Gad^.GadgetID Of
                          1: If ActivateGadget(SGad,WinReq,Nil) Then;
                          3: If FReq<>Nil Then Begin
                               SInfo:=SGad^.SpecialInfo;
                               Tags[1]:=TagItem(ASLFR_InitialDrawer ,Long(SInfo^.Buffer));
                               Tags[2].ti_Tag:=TAG_DONE;
                               If AslRequest(FReq,^Tags) Then Begin
                                 Tags[1]:=TagItem(GTST_String ,Long(FReq^.fr_Drawer));
                                 GT_SetGadgetAttrsA(SGad,WinReq,Nil,^Tags);
                               End;
                             End;
                          4: Begin
                               SInfo:=SGad^.SpecialInfo;
                               myLock:=Lock(SInfo^.Buffer,-2);
                               If myLock<>0 Then Begin
                                 SInfo:=IGad^.SpecialInfo;
                                 Txt:=SInfo^.Buffer;
                                 If (Txt='') Then
                                   Txt:='XOpaAssign';
                                 If Txt[Length(Txt)]=':' Then
                                   Txt:=Copy(Txt,1,Length(Txt)-1);
                                 If AssignLock(Txt,myLock)=0 Then
                                   ErrorRequest('Zuweisung auf Verzeichnis|ist fehlgeschlagen.',false);
                               End Else
                                 ErrorRequest('Zugriff auf Verzeichnis|'+SInfo^.Buffer+'|ist fehlgeschlagen.',false);
                               AktNode:=Nil;
                               ok:=true;
                             End;
                          5: ok:=true;
                        Else;
                        End;
                      End;
    Else;
    End;
    GT_ReplyIMsg(MsgReq);
  Until ok;
  If FReq<>Nil Then
    FreeAslRequest(FReq);
  CloseWindow(WinReq);
  FreeGadgets(GadLst);
  SetWaitPointer(false);
END;


PROCEDURE SetSignal;

VAR     WinReq  :^Window;
        MsgReq  :^IntuiMessage;
        GadLst  :^Gadget;
        NGad    :Array[1..4] of NewGadget;
        Gad,FGad:^Gadget;
        IGad    :^Gadget;
        myTask  :^Task;
        Tags    :Array[1..5] of TagItem;
        WinTags :Array[1..10] of TagItem;
        SInfo   :^StringInfo;
        WinTitle:AppString;
        Txt     :AppString;
        ok      :Boolean;
        MXStr   :Array[1..3] of Str;
        MXGad   :^Gadget;
        MXStatus:Word;
                                                {sendet einem Task ein benutzerdefinierbares Signal}
BEGIN
  SetWaitPointer(true);
  myTask:=AktNode^.Address;
  FGad:=CreateContext(^GadLst);
  If FGad=Nil Then
    ErrorRequest('Probleme mit GadTools.',true);
  WinTitle:='XOpa-Signal senden';
  WinTags[1]:=TagItem(WA_Width,       TLn('AbbrechenZurck')+166);
  WinTags[2]:=TagItem(WA_Height,      PubScr^.BarHeight+3*PubScr^.Font^.ta_YSize+28);
  WinTags[3]:=TagItem(WA_IDCMP,       IDCMP_GADGETUP or IDCMP_GADGETDOWN or IDCMP_CLOSEWINDOW);
  WinTags[4]:=TagItem(WA_Flags,       WFLG_DEPTHGADGET or WFLG_DRAGBAR or WFLG_ACTIVATE or WFLG_CLOSEGADGET);
  WinTags[5]:=TagItem(WA_Title,       Long(^WinTitle));
  WinTags[6]:=TagItem(WA_Gadgets,     Long(FGad));
  WinTags[7]:=TagItem(WA_Left,        Win^.LeftEdge+Win^.Width shr 1-WinTags[1].ti_Data shr 1);
  WinTags[8]:=TagItem(WA_Top,         Win^.TopEdge+Win^.Height shr 1-WinTags[2].ti_Data shr 1);
  WinTags[9].ti_Tag:=TAG_DONE;
  NGad[1]:=NewGadget(8,PubScr^.BarHeight+4,16,PubScr^.Font^.ta_YSize+3,Nil,PubScr^.Font,1,PLACETEXT_RIGHT,VInfo,Nil);
  NGad[2]:=NewGadget(40+TLn('Signal:'),PubScr^.BarHeight+4,WinTags[1].ti_Data-48-TLn('Signal:'),PubScr^.Font^.ta_YSize+5,Nil,PubScr^.Font,2,0,VInfo,Nil);
  NGad[3]:=NewGadget(8,PubScr^.BarHeight+20+2*PubScr^.Font^.ta_YSize,TLn('Zurck')+50,PubScr^.Font^.ta_YSize+3,'Ok',PubScr^.Font,3,0,VInfo,Nil);
  NGad[4]:=NewGadget(WinTags[1].ti_Data-58-TLn('Zurck'),PubScr^.BarHeight+20+2*PubScr^.Font^.ta_YSize,TLn('Zurck')+50,PubScr^.Font^.ta_YSize+3,'Zurck',PubScr^.Font,4,0,VInfo,Nil);
  MXStr[1]:='Signal:';
  MXStr[2]:='Abbrechen (CTRL-C/D/E/F)';
  MXStr[3]:=Nil;
  Tags[1]:=TagItem(GTMX_Labels,            Long(^MXStr[1]));
  Tags[2]:=TagItem(GTMX_Spacing,           6);
  Tags[3].ti_Tag:=TAG_DONE;
  MXGad:=CreateGadgetA(MX_KIND,FGad,^NGad[1],^Tags);
  Txt:=Dez2Hex(myTask^.tc_SigAlloc);
  Tags[1]:=TagItem(GTST_String,            Long(^Txt));
  Tags[2]:=TagItem(STRINGA_Justification,  GACT_STRINGRIGHT);
  Tags[3]:=TagItem(GTST_MaxChars,          8);
  Tags[4].ti_Tag:=TAG_DONE;
  IGad:=CreateGadgetA(STRING_KIND,MXGad,^NGad[2],^Tags);
  Gad:=CreateGadgetA(BUTTON_KIND,IGad,^NGad[3],Nil);
  Gad:=CreateGadgetA(BUTTON_KIND,Gad,^NGad[4],Nil);
  WinReq:=OpenWindowTagList(Nil, ^WinTags);
  If WinReq=Nil Then
    ErrorRequest('Konnte Fenster nicht ffnen.',true);
  GT_RefreshWindow(WinReq, Nil);
  SInfo:=IGad^.SpecialInfo;
  ok:=false;
  Repeat
    MsgReq:=Wait_Port(WinReq^.UserPort);
    MsgReq:=GT_GetIMsg(WinReq^.UserPort);
    Case MsgReq^.Class Of
      IDCMP_CLOSEWINDOW: ok:=true;
      IDCMP_GADGETDOWN: Begin
                          Gad:=MsgReq^.IAddress;
                          If Gad^.GadgetID=1 Then
                            MXStatus:=MsgReq^.Code;
                        End;
      IDCMP_GADGETUP: Begin
                        Gad:=MsgReq^.IAddress;
                        If (Gad^.GadgetID=3) Then Begin
                          If MXStatus=0 Then Begin
                            SInfo:=IGad^.SpecialInfo;
                            Txt:=SInfo^.Buffer;
                            Signal(myTask, DecryptHex(Txt));
                            AktNode:=Nil;
                          End Else Begin
                            Signal(myTask, myTask^.tc_SigAlloc);
                            AktNode:=Nil;
                          End;
                        End;
                        If Gad^.GadgetID>2 Then
                          ok:=true;
                      End;
    Else;
    End;
    GT_ReplyIMsg(MsgReq);
  Until ok;
  CloseWindow(WinReq);
  FreeGadgets(GadLst);
  If AktNode=Nil Then
    Delay(30);
  SetWaitPointer(false);
END;


PROCEDURE ChangePriority;

VAR     WinReq  :^Window;
        MsgReq  :^IntuiMessage;
        GadLst  :^Gadget;
        NGad    :Array[1..3] of NewGadget;
        Gad,FGad:^Gadget;
        IGad    :^Gadget;
        myNode  :^Node;
        Tags    :Array[1..5] of TagItem;
        WinTags :Array[1..10] of TagItem;
        SInfo   :^StringInfo;
        Txt     :AppString;
        ok      :Boolean;
                                                {ndert Prioritt von allem Objekt}
BEGIN
  SetWaitPointer(true);
  myNode:=AktNode^.Address;
  FGad:=CreateContext(^GadLst);
  If FGad=Nil Then
    ErrorRequest('Ciao Mdels!',true);
  Txt:='XOpa-Prioritt ndern';
  WinTags[1]:=TagItem(WA_Width,       TLn('PriotittZurck')+166);
  WinTags[2]:=TagItem(WA_Height,      PubScr^.BarHeight+2*PubScr^.Font^.ta_YSize+21);
  WinTags[3]:=TagItem(WA_IDCMP,       IDCMP_GADGETUP or IDCMP_CLOSEWINDOW);
  WinTags[4]:=TagItem(WA_Flags,       WFLG_DEPTHGADGET or WFLG_DRAGBAR or WFLG_ACTIVATE or WFLG_CLOSEGADGET);
  WinTags[5]:=TagItem(WA_Title,       Long(^Txt));
  WinTags[6]:=TagItem(WA_Gadgets,     Long(FGad));
  WinTags[7]:=TagItem(WA_Left,        Win^.LeftEdge+Win^.Width shr 1-WinTags[1].ti_Data shr 1);
  WinTags[8]:=TagItem(WA_Top,         Win^.TopEdge+Win^.Height shr 1-WinTags[2].ti_Data shr 1);
  WinTags[9].ti_Tag:=TAG_DONE;
  NGad[1]:=NewGadget(16+TLn('Prioritt:'),PubScr^.BarHeight+4,WinTags[1].ti_Data-24-TLn('Prioritt:'),PubScr^.Font^.ta_YSize+5,'Prioritt:',PubScr^.Font,1,0,VInfo,Nil);
  NGad[2]:=NewGadget(8,PubScr^.BarHeight+13+PubScr^.Font^.ta_YSize,TLn('Zurck')+50,PubScr^.Font^.ta_YSize+3,'Ok',PubScr^.Font,2,0,VInfo,Nil);
  NGad[3]:=NewGadget(WinTags[1].ti_Data-58-TLn('Zurck'),PubScr^.BarHeight+13+PubScr^.Font^.ta_YSize,TLn('Zurck')+50,PubScr^.Font^.ta_YSize+3,'Zurck',PubScr^.Font,3,0,VInfo,Nil);
  Tags[1]:=TagItem(GTIN_Number,            Long(myNode^.ln_Pri));
  Tags[2]:=TagItem(STRINGA_Justification,  GACT_STRINGRIGHT);
  Tags[3].ti_Tag:=TAG_DONE;
  IGad:=CreateGadgetA(INTEGER_KIND,FGad,^NGad[1],^Tags);
  Gad:=CreateGadgetA(BUTTON_KIND,IGad,^NGad[2],Nil);
  Gad:=CreateGadgetA(BUTTON_KIND,Gad,^NGad[3],Nil);
  WinReq:=OpenWindowTagList(Nil, ^WinTags);
  If WinReq=Nil Then
    ErrorRequest('Konnte Fenster nicht ffnen.',true);
  ok:=false;
  If ActivateGadget(IGad,WinReq,Nil) Then;
  Repeat
    MsgReq:=Wait_Port(WinReq^.UserPort);
    MsgReq:=GT_GetIMsg(WinReq^.UserPort);
    Case MsgReq^.Class Of
      IDCMP_CLOSEWINDOW: ok:=true;
      IDCMP_GADGETUP: Begin
                        Gad:=MsgReq^.IAddress;
                        If Gad^.GadgetID=2 Then Begin
                          SInfo:=IGad^.SpecialInfo;
                          If (SInfo^.LongInt>127) Then
                            SInfo^.LongInt:=127;
                          If (SInfo^.LongInt<-128) Then
                            SInfo^.LongInt:=-128;
                          {If (DispMode=1) or (DispMode=21) Then}
                          dum:=SetTaskPri(^myNode^,SInfo^.LongInt);
                          AktNode:=Nil;
                        End;
                        If Gad^.GadgetID<>1 Then
                          ok:=true;
                      End;
    Else;
    End;
    GT_ReplyIMsg(MsgReq);
  Until ok;
  CloseWindow(WinReq);
  FreeGadgets(GadLst);
  If AktNode=Nil Then
    Delay(15);
  SetWaitPointer(false);
END;

{Die folgenden Routinen sind fr den Strukturmodus}

PROCEDURE AddLibTyp(Txt1,Txt2 :String);

VAR     AktLib  :^Libtyp;
                                                {Strukturmodus: hngt Library-Zuweisung (welche Liste bei welcher Library?) an}
BEGIN
  New(AktLib);
  AktLib^.Name:=Txt1;
  AktLib^.Struct:=Txt2;
  AktLib^.Node.ln_Name:=AktLib^.Name;
  AddTail(^Libraries,^AktLib^);
END;


FUNCTION AddStruct(Txt :String) : p_Struct;

VAR     myStruct        :^Struct;
                                                {Strukturmodus: fgt Struktur hinzu und sortiert diese ein}
BEGIN
  New(AktStruct);
  NewList(^AktStruct^.Entrys);
  AktStruct^.Name:=Txt;
  AktStruct^.Length:=0;
  AktStruct^.Node.ln_Name:=AktStruct^.Name;
  If Structs.lh_Head=^Structs.lh_Tail Then
    AddTail(^Structs,^AktStruct^)
  Else Begin
    myStruct:=p_Struct(Structs.lh_TailPred);
    If Txt>myStruct^.Name Then
      AddTail(^Structs,^AktStruct^)
    Else Begin
      myStruct:=p_Struct(Structs.lh_Head);
      If Txt<myStruct^.Name Then
        AddHead(^Structs,^AktStruct^)
      Else Begin
        While (myStruct^.Node.ln_Succ<>Nil) and (Txt>myStruct^.Name) Do
          myStruct:=p_Struct(myStruct^.Node.ln_Succ);
        Insert(^Structs,^AktStruct^,myStruct^.Node.ln_Pred);
      End;
    End;
  End;
  AddStruct:=AktStruct;
END;


PROCEDURE AddStructTyp(Txt :String;Typ :Byte;StructTxt :String);

VAR     myStruct :^Struct;
                                                {Strukturmodus: hngt einer Struktur einen Eintrag an}
BEGIN
  New(AktStructTyp);
  AktStructTyp^.Name:=Txt;
  AktStructTyp^.Node.ln_Type:=Typ;
  Case Typ Of
    STRUCT_LONG,STRUCT_PSTRUCT,STRUCT_FLGLONG,STRUCT_PTR,STRUCT_STRING,STRUCT_BPTR: AktStruct^.Length:=AktStruct^.Length+4;
    STRUCT_WORD,STRUCT_UWORD,STRUCT_FLGWORD: AktStruct^.Length:=AktStruct^.Length+2;
    STRUCT_BYTE,STRUCT_UBYTE,STRUCT_FLGBYTE: Inc(AktStruct^.Length);
    STRUCT_STRUCT: Begin
                     myStruct:=p_Struct(FindName(^Structs,StructTxt));
                     If myStruct<>Nil Then
                       AktStruct^.Length:=AktStruct^.Length+myStruct^.Length
                     Else Begin
                       ErrorRequest('Struktur "'+AktStruct^.Name+'" fehlerhaft:|Die Struktur "'+StructTxt+'" konnte nicht gefunden werden.|berprfen Sie die Datei "'+StructName+'".',false);
                       StructTxt:=StructTxt+' <- Fehlerhaft !!!';
                     End;
                   End;
  Else;
  End;
  AktStructTyp^.Typ:=StructTxt;
  AktStructTyp^.Node.ln_Name:=AktStructTyp^.Name;
  AddTail(^AktStruct^.Entrys,^AktStructTyp^);
END;


PROCEDURE LoadStructs;

VAR     dat     :Text;
        Txt,Txt1:AppString;
                                                {initialisiert Standardstrukturen und ldt Strukturdatei von Diskette}
  PROCEDURE AddInternalStructs;

  BEGIN
    AddLibTyp('exec.library','SysBase');
    AktStruct:=AddStruct('MinNode');
     AddStructTyp('mln_Succ'    ,STRUCT_PSTRUCT,'MinNode');
     AddStructTyp('mln_Pred'    ,STRUCT_PSTRUCT,'MinNode');
    AktStruct:=AddStruct('Node');
     AddStructTyp('ln_Succ'     ,STRUCT_PSTRUCT,'Node');
     AddStructTyp('ln_Pred'     ,STRUCT_PSTRUCT,'Node');
     AddStructTyp('ln_Type'     ,STRUCT_UBYTE,'');
     AddStructTyp('ln_Pri'      ,STRUCT_BYTE,'');
     AddStructTyp('ln_Name'     ,STRUCT_STRING,'');
    AktStruct:=AddStruct('MinList');
     AddStructTyp('mlh_Head'    ,STRUCT_PSTRUCT,'MinNode');
     AddStructTyp('mlh_Tail'    ,STRUCT_PSTRUCT,'MinNode');
     AddStructTyp('mlh_TailPred',STRUCT_PSTRUCT,'MinNode');
    AktStruct:=AddStruct('List');
     AddStructTyp('lh_Head'     ,STRUCT_PSTRUCT,'Node');
     AddStructTyp('lh_Tail'     ,STRUCT_PSTRUCT,'Node');
     AddStructTyp('lh_TailPred' ,STRUCT_PSTRUCT,'Node');
     AddStructTyp('lh_Type'     ,STRUCT_UBYTE,'');
     AddStructTyp('l_Pad'       ,STRUCT_UBYTE,'');
    AktStruct:=AddStruct('Library');
     AddStructTyp('lib_Node'    ,STRUCT_STRUCT,'Node');
     AddStructTyp('lib_Flags'   ,STRUCT_UBYTE,'');
     AddStructTyp('lib_Pad'     ,STRUCT_UBYTE,'');
     AddStructTyp('lib_NegSize' ,STRUCT_UWORD,'');
     AddStructTyp('lib_PosSize' ,STRUCT_UWORD,'');
     AddStructTyp('lib_Version' ,STRUCT_UWORD,'');
     AddStructTyp('lib_Revision',STRUCT_UWORD,'');
     AddStructTyp('lib_IdString',STRUCT_STRING,'');
     AddStructTyp('lib_Sum'     ,STRUCT_LONG,'');
     AddStructTyp('lib_OpenCnt' ,STRUCT_UWORD,'');
    AktStruct:=AddStruct('IntVector');
     AddStructTyp('iv_Data'     ,STRUCT_PTR,'XPTR');
     AddStructTyp('iv_Code'     ,STRUCT_PTR,'XPTR');
     AddStructTyp('iv_Node'     ,STRUCT_PSTRUCT,'Node');
    AktStruct:=AddStruct('SoftIntList');
     AddStructTyp('sh_List'     ,STRUCT_STRUCT,'List');
     AddStructTyp('sh_Pad'      ,STRUCT_UWORD,'');
    AktStruct:=AddStruct('MsgPort');
     AddStructTyp('mp_Node'     ,STRUCT_STRUCT,'Node');
     AddStructTyp('mp_Flags'    ,STRUCT_FLGBYTE,'');
     AddStructTyp('mp_SigBit'   ,STRUCT_UBYTE,'');
     AddStructTyp('mp_SigTask'  ,STRUCT_PSTRUCT,'Task');
     AddStructTyp('mp_MsgList'  ,STRUCT_STRUCT,'List');
    AktStruct:=AddStruct('Device');
     AddStructTyp('dd_Library'  ,STRUCT_STRUCT,'Library');
    AktStruct:=AddStruct('SysBase');
     AddStructTyp('LibNode'     ,STRUCT_STRUCT,'Library');
     AddStructTyp('SoftVer'     ,STRUCT_UWORD,'');
     AddStructTyp('LowMemChkSum',STRUCT_WORD,'');
     AddStructTyp('ChkBase'     ,STRUCT_LONG,'');
     AddStructTyp('ColdCapture' ,STRUCT_PTR,'XPTR');
     AddStructTyp('CoolCapture' ,STRUCT_PTR,'XPTR');
     AddStructTyp('WarmCapture' ,STRUCT_PTR,'XPTR');
     AddStructTyp('SysStkUpper' ,STRUCT_PTR,'XPTR');
     AddStructTyp('SysStkLower' ,STRUCT_PTR,'XPTR');
     AddStructTyp('MaxLocMem'   ,STRUCT_LONG,'');
     AddStructTyp('DebugEntry'  ,STRUCT_PTR,'XPTR');
     AddStructTyp('DebugData'   ,STRUCT_PTR,'XPTR');
     AddStructTyp('AlertData'   ,STRUCT_PTR,'XPTR');
     AddStructTyp('MaxExtMem'   ,STRUCT_PTR,'XPTR');
     AddStructTyp('ChkSum'      ,STRUCT_UWORD,'');
     AddStructTyp('IntVects[0]' ,STRUCT_STRUCT,'IntVector');
     AddStructTyp('IntVects[1]' ,STRUCT_STRUCT,'IntVector');
     AddStructTyp('IntVects[2]' ,STRUCT_STRUCT,'IntVector');
     AddStructTyp('IntVects[3]' ,STRUCT_STRUCT,'IntVector');
     AddStructTyp('IntVects[4]' ,STRUCT_STRUCT,'IntVector');
     AddStructTyp('IntVects[5]' ,STRUCT_STRUCT,'IntVector');
     AddStructTyp('IntVects[6]' ,STRUCT_STRUCT,'IntVector');
     AddStructTyp('IntVects[7]' ,STRUCT_STRUCT,'IntVector');
     AddStructTyp('IntVects[8]' ,STRUCT_STRUCT,'IntVector');
     AddStructTyp('IntVects[9]' ,STRUCT_STRUCT,'IntVector');
     AddStructTyp('IntVects[10]',STRUCT_STRUCT,'IntVector');
     AddStructTyp('IntVects[11]',STRUCT_STRUCT,'IntVector');
     AddStructTyp('IntVects[12]',STRUCT_STRUCT,'IntVector');
     AddStructTyp('IntVects[13]',STRUCT_STRUCT,'IntVector');
     AddStructTyp('IntVects[14]',STRUCT_STRUCT,'IntVector');
     AddStructTyp('IntVects[15]',STRUCT_STRUCT,'IntVector');
     AddStructTyp('ThisTask'    ,STRUCT_PSTRUCT,'Task');
     AddStructTyp('IdleCount'   ,STRUCT_LONG,'');
     AddStructTyp('DispCount'   ,STRUCT_LONG,'');
     AddStructTyp('Quantum'     ,STRUCT_UWORD,'');
     AddStructTyp('Elapsed'     ,STRUCT_UWORD,'');
     AddStructTyp('SysFlags'    ,STRUCT_FLGWORD,'');
     AddStructTyp('IDNestCnt'   ,STRUCT_BYTE,'');
     AddStructTyp('TDNestCnt'   ,STRUCT_BYTE,'');
     AddStructTyp('AttnFlags'   ,STRUCT_FLGWORD,'');
     AddStructTyp('AttnResched' ,STRUCT_UWORD,'');
     AddStructTyp('ResModules'  ,STRUCT_PTR,'XPTR');
     AddStructTyp('TaskTrapCode',STRUCT_PTR,'XPTR');
     AddStructTyp('TaskExceptCode',STRUCT_PTR,'XPTR');
     AddStructTyp('TaskExitCode',STRUCT_PTR,'XPTR');
     AddStructTyp('TaskSigAlloc',STRUCT_FLGLONG,'');
     AddStructTyp('TaskTrapAlloc',STRUCT_FLGWORD,'');
     AddStructTyp('MemList'     ,STRUCT_STRUCT,'List');
     AddStructTyp('ResourceList',STRUCT_STRUCT,'List');
     AddStructTyp('DeviceList'  ,STRUCT_STRUCT,'List');
     AddStructTyp('IntrList'    ,STRUCT_STRUCT,'List');
     AddStructTyp('LibList'     ,STRUCT_STRUCT,'List');
     AddStructTyp('PortList'    ,STRUCT_STRUCT,'List');
     AddStructTyp('TaskReady'   ,STRUCT_STRUCT,'List');
     AddStructTyp('TaskWait'    ,STRUCT_STRUCT,'List');
     AddStructTyp('SoftInts[0]' ,STRUCT_STRUCT,'SoftIntList');
     AddStructTyp('SoftInts[1]' ,STRUCT_STRUCT,'SoftIntList');
     AddStructTyp('SoftInts[2]' ,STRUCT_STRUCT,'SoftIntList');
     AddStructTyp('SoftInts[3]' ,STRUCT_STRUCT,'SoftIntList');
     AddStructTyp('SoftInts[4]' ,STRUCT_STRUCT,'SoftIntList');
     AddStructTyp('LastAlert[0]',STRUCT_FLGLONG,'');
     AddStructTyp('LastAlert[1]',STRUCT_FLGLONG,'');
     AddStructTyp('LastAlert[2]',STRUCT_FLGLONG,'');
     AddStructTyp('LastAlert[3]',STRUCT_FLGLONG,'');
     AddStructTyp('VBlankFrequency',STRUCT_UBYTE,'');
     AddStructTyp('PowerSupplyFrequency',STRUCT_UBYTE,'');
     AddStructTyp('SemaphoreList',STRUCT_STRUCT,'List');
     AddStructTyp('KickMemPtr'  ,STRUCT_PTR,'XPTR');
     AddStructTyp('KickTagPtr'  ,STRUCT_PTR,'XPTR');
     AddStructTyp('KickCheckSum',STRUCT_PTR,'XPTR');
     AddStructTyp('ex_Pad0'     ,STRUCT_UWORD,'');
     AddStructTyp('ex_Reserved0',STRUCT_LONG,'');
     AddStructTyp('ex_RamLibPrivate',STRUCT_PTR,'XPTR');
     AddStructTyp('ex_EClockFrequency',STRUCT_LONG,'');
     AddStructTyp('ex_CacheControl',STRUCT_FLGLONG,'');
     AddStructTyp('ex_TaskID'   ,STRUCT_LONG,'');
     AddStructTyp('ex_PuddleSize',STRUCT_LONG,'');
     AddStructTyp('ex_PoolThreshold',STRUCT_LONG,'');
     AddStructTyp('ex_PublicPool',STRUCT_STRUCT,'MinList');
     AddStructTyp('ex_MMULock'  ,STRUCT_PTR,'XPTR');
     AddStructTyp('ex_Reserved[0]',STRUCT_LONG,'');
     AddStructTyp('ex_Reserved[1]',STRUCT_LONG,'');
     AddStructTyp('ex_Reserved[2]',STRUCT_LONG,'');
     AddStructTyp('ex_Reserved[3]',STRUCT_LONG,'');
     AddStructTyp('ex_MemHandlers',STRUCT_STRUCT,'MinList');
     AddStructTyp('ex_MemHandler',STRUCT_PTR,'XPTR');
    {AddStructTyp('',STRUCT_,'');}
    AktStruct:=Nil;
  END;

  PROCEDURE ReadIt;

  BEGIN
    ReadLn(dat,Txt);
    While ((Txt='') or (Txt[1]=';')) and (IOResult=0) and (Not EoF(dat)) Do
      ReadLn(dat,Txt);
  END;

BEGIN
  AddInternalStructs;
  Reset(dat,StructName);
  If IOResult<>0 Then Begin
    If StructName<>'XOpa.structs' Then Begin
      StructName:='XOpa.structs';
      Reset(dat,StructName);
    End;
    If IOResult<>0 Then Begin
      ErrorRequest('Konnte Strukturdefinitionen nicht finden.|Die Datei "XOpa.structs" befindet|sich nicht im Verzeichnis von XOpa.',false);
      Exit;
    End Else
      ErrorRequest('Konnte die in den ToolTypes eingestellte|Strukturdefinitions-Datei nicht finden.',false);
  End;
  Buffer(dat,14200);
  ReadIt;
  If Txt<>'# --==**> XOpa-Strukturdefinition' Then Begin
    ErrorRequest('"'+StructName+'" ist keine|Strukturdefinitions-Datei. berschreiben Sie|sie bitte mit dem Original',false);
    Close(dat);
    Exit;
  End;
  While (Not EoF(dat)) and (IOResult=0) Do Begin
    ReadIt;
    If Txt='#libraries' Then Begin
      ReadIt;
      While (Txt[1]<>'#') and (IOResult=0) Do Begin
        Txt1:=Copy(Txt,Pos('=',Txt)+1,Length(Txt));
        Txt:=Copy(Txt,1,Pos('=',Txt)-1);
        AddLibTyp(Txt,Txt1);
        ReadIt;
      End;
    End;
    If Txt='#structs' Then Begin
      ReadIt;
      While (Txt[1]<>'#') and (IOResult=0) Do Begin
        If Pos('@struct=',Txt)=1 Then Begin
          Txt:=Copy(Txt,9,Length(Txt));
          AktStruct:=AddStruct(Txt);
          ReadIt;
          While (Txt[1]<>'@') and (Txt[1]<>'#') and (IOResult=0) Do Begin
            Txt1:=Copy(Txt,Pos(':',Txt)+1,Length(Txt));
            Txt:=Copy(Txt,1,Pos(':',Txt)-1);
            If Pos(' ',Txt)>0 Then
              Txt:=Copy(Txt,1,Pos(' ',Txt)-1);
            If Txt1[1]='^' Then Begin
              Txt1:=Copy(Txt1,2,Length(Txt1));
              dum:=STRUCT_PSTRUCT
            End Else If Txt1='WORD' Then
              dum:=STRUCT_WORD
            Else If Txt1='UWORD' Then
              dum:=STRUCT_UWORD
            Else If Txt1='FLGWORD' Then
              dum:=STRUCT_FLGWORD
            Else If Txt1='BYTE' Then
              dum:=STRUCT_BYTE
            Else If Txt1='UBYTE' Then
              dum:=STRUCT_UBYTE
            Else If Txt1='FLGBYTE' Then
              dum:=STRUCT_FLGBYTE
            Else If Txt1='LONG' Then
              dum:=STRUCT_LONG
            Else If Txt1='FLGLONG' Then
              dum:=STRUCT_FLGLONG
            Else If Txt1='PTR' Then Begin
              dum:=STRUCT_PTR;
              Txt1:='XPTR'
            End Else If Txt1='BPTR' Then Begin
              dum:=STRUCT_BPTR;
              Txt1:='XPTR'
            End Else If Txt1='STR' Then
              dum:=STRUCT_STRING
            Else
              dum:=STRUCT_STRUCT;
            AddStructTyp(Txt,dum,Txt1);
            ReadIt;
          End;
        End;
      End;
    End;
    If Txt='#end' Then
      ReadIt;
  End;
  Close(dat);
  NodeTypen[1]:=p_Struct(FindName(^Structs,'Message'));
  NodeTypen[2]:=NodeTypen[1];  NodeTypen[3]:=NodeTypen[1];
  NodeTypen[4]:=p_Struct(FindName(^Structs,'Library'));
  NodeTypen[5]:=p_Struct(FindName(^Structs,'MonitorSpec'));
  AktStruct:=Nil;
END;


PROCEDURE NodeStruktur;

VAR     WinReq  :^Window;
        MsgReq  :^IntuiMessage;
        GadLst  :^Gadget;
        NGad    :Array[1..4] of NewGadget;
        Gad,FGad:^Gadget;
        LVGad   :^Gadget;
        Tags    :Array[1..5] of TagItem;
        WinTags :Array[1..10] of TagItem;
        WinTitle:AppString;
        Txt     :AppString;
        Ende    :Boolean;
        ok      :Boolean;
        LVAkt   :Array[0..4] of Word;
        CycAkt,i:Word;
        myStruct:^Struct;
        NTyps   :Array[0..5] of Str;
                                                {legt Standardstrukturen fr verschiedene Node-Typen fest}
BEGIN
  If Structs.lh_Head=^Structs.lh_Tail Then
    LoadStructs;
  FGad:=CreateContext(^GadLst);
  If FGad=Nil Then
    ErrorRequest('Ciao Mdels!',true);
  WinTitle:='XOpa-Standard-Struktur fr "Nodes" whlen';
  WinTags[1]:=TagItem(WA_Width,       TLn('IntuitionBaseZurck')+100);
  WinTags[2]:=TagItem(WA_Height,      PubScr^.BarHeight+10*PubScr^.Font^.ta_YSize+32);
  WinTags[3]:=TagItem(WA_IDCMP,       IDCMP_CLOSEWINDOW or IDCMP_GADGETUP or LISTVIEWIDCMP);
  WinTags[4]:=TagItem(WA_Flags,       WFLG_DEPTHGADGET or WFLG_DRAGBAR or WFLG_ACTIVATE or WFLG_CLOSEGADGET);
  WinTags[5]:=TagItem(WA_Title,       Long(^WinTitle));
  WinTags[6]:=TagItem(WA_Gadgets,     Long(FGad));
  WinTags[7]:=TagItem(WA_Left,        Win^.LeftEdge+Win^.Width shr 1-WinTags[1].ti_Data shr 1);
  WinTags[8]:=TagItem(WA_Top,         Win^.TopEdge+Win^.Height shr 1-WinTags[2].ti_Data shr 1);
  WinTags[9].ti_Tag:=TAG_DONE;
  For i:=0 to 4 Do Begin
    If NodeTypen[i+1]=Nil Then
      NodeTypen[i+1]:=p_Struct(FindName(^Structs,'Node'));
    myStruct:=p_Struct(Structs.lh_Head);  dum:=0;
    While (myStruct^.Node.ln_Succ<>Nil) and (myStruct<>NodeTypen[i+1]) Do Begin
      Inc(dum);
      myStruct:=p_Struct(myStruct^.Node.ln_Succ);
    End;
    LVAkt[i]:=dum;
  End;
  NTyps[0]:='NT_MESSAGE';  NTyps[1]:='NT_FREEMSG';  NTyps[2]:='NT_REPLYMSG';  NTyps[3]:='NT_RESOURCE';  NTyps[4]:='NT_GRAPHICS';  NTyps[5]:=Nil;  CycAkt:=0;
  NGad[1]:=NewGadget(16+TLn('Node-Typ:'),PubScr^.BarHeight+4,WinTags[1].ti_Data-24-TLn('Node-Typ:'),
                     PubScr^.Font^.ta_YSize+4,'Node-Typ:',PubScr^.Font,1,PLACETEXT_LEFT,VInfo,Nil);
  NGad[2]:=NewGadget(8,PubScr^.BarHeight+17+2*PubScr^.Font^.ta_YSize,WinTags[1].ti_Data-16,7*PubScr^.Font^.ta_YSize+4,'Standard-Struktur',PubScr^.Font,2,PLACETEXT_ABOVE,VInfo,Nil);
  NGad[3]:=NewGadget(8,PubScr^.BarHeight+24+9*PubScr^.Font^.ta_YSize,TLn('Zurck')+50,PubScr^.Font^.ta_YSize+4,'Ok',PubScr^.Font,3,0,VInfo,Nil);
  NGad[4]:=NewGadget(WinTags[1].ti_Data-58-TLn('Zurck'),PubScr^.BarHeight+24+9*PubScr^.Font^.ta_YSize,TLn('Zurck')+50,PubScr^.Font^.ta_YSize+4,'Zurck',PubScr^.Font,4,0,VInfo,Nil);
  Txt:=Dez2Hex(Long(StructAddress));
  Tags[1]:=TagItem(GTCY_Labels,            Long(^NTyps));
  Tags[2].ti_Tag:=TAG_DONE;
  Gad:=CreateGadgetA(CYCLE_KIND,FGad,^NGad[1],^Tags);
  Tags[1]:=TagItem(GTLV_Labels,            Long(^Structs));
  Tags[2]:=TagItem(GTLV_ShowSelected,      0);
  Tags[3]:=TagItem(GTLV_Selected,          LVAkt[0]);
  If IntuitionBase^.LibNode.lib_Version>38 Then
    Tags[4]:=TagItem(GTLV_MakeVisible,LVAkt[0])
  Else
    Tags[4]:=TagItem(GTLV_Top        ,LVAkt[0]);
  Tags[5].ti_Tag:=TAG_DONE;
  LVGad:=CreateGadgetA(LISTVIEW_KIND,Gad,^NGad[2],^Tags);
  Gad:=CreateGadgetA(BUTTON_KIND,LVGad,^NGad[3],Nil);
  Gad:=CreateGadgetA(BUTTON_KIND,Gad,^NGad[4],Nil);
  WinReq:=OpenWindowTagList(Nil, ^WinTags);
  If Win=Nil Then
    ErrorRequest('Konnte Fenster nicht ffnen.',true);
  GT_RefreshWindow(WinReq, Nil);
  ok:=false;  Ende:=false;
  Repeat
    MsgReq:=Wait_Port(WinReq^.UserPort);
    MsgReq:=GT_GetIMsg(WinReq^.UserPort);
    Case MsgReq^.Class Of
      IDCMP_CLOSEWINDOW: Ende:=true;
      IDCMP_GADGETUP: Begin
                        Gad:=MsgReq^.IAddress;
                        Case Gad^.GadgetID Of
                          1: Begin
                               CycAkt:=MsgReq^.Code;
                               Tags[1]:=TagItem(GTLV_Selected,     LVAkt[CycAkt]);
                               If IntuitionBase^.LibNode.lib_Version>38 Then
                                 Tags[2]:=TagItem(GTLV_MakeVisible,LVAkt[CycAkt])
                               Else
                                 Tags[2]:=TagItem(GTLV_Top        ,LVAkt[CycAkt]);
                               Tags[3].ti_Tag:=TAG_DONE;
                               GT_SetGadgetAttrsA(LVGad, WinReq, Nil, ^Tags);
                             End;
                          2: LVAkt[CycAkt]:=MsgReq^.Code;
                          3: Begin
                               ok:=true;
                               Ende:=true;
                             End;
                          4: Ende:=true;
                        Else;
                        End;
                      End;
    Else;
    End;
    GT_ReplyIMsg(MsgReq);
  Until Ende;
  CloseWindow(WinReq);
  If ok Then Begin
    For i:=0 to 4 Do Begin
      myStruct:=p_Struct(Structs.lh_Head);  dum:=0;
      While (myStruct^.Node.ln_Succ<>Nil) and (dum<LVAkt[i]) Do Begin
        Inc(dum);
        myStruct:=p_Struct(myStruct^.Node.ln_Succ);
      End;
      NodeTypen[i+1]:=myStruct;
    End;
  End;
  FreeGadgets(GadLst);
END;


FUNCTION AndereStruktur(VAR StructAddress :Ptr) : p_Struct;

VAR     WinReq  :^Window;
        MsgReq  :^IntuiMessage;
        GadLst  :^Gadget;
        NGad    :Array[1..4] of NewGadget;
        Gad,FGad:^Gadget;
        IGad    :^Gadget;
        Tags    :Array[1..5] of TagItem;
        WinTags :Array[1..10] of TagItem;
        SInfo   :^StringInfo;
        WinTitle:AppString;
        Txt     :AppString;
        Ende    :Boolean;
        ok      :Boolean;
        LVAkt   :Integer;
        myStruct:^Struct;
                                                {ndert aktuell angezeigte Struktur und Adresse}
BEGIN
  AndereStruktur:=Nil;
  FGad:=CreateContext(^GadLst);
  If FGad=Nil Then
    ErrorRequest('Ciao Mdels!',true);
  WinTitle:='XOpa-Struktur whlen';
  WinTags[1]:=TagItem(WA_Width,       TLn('IntuitionBaseZurck')+100);
  WinTags[2]:=TagItem(WA_Height,      PubScr^.BarHeight+10*PubScr^.Font^.ta_YSize+28);
  WinTags[3]:=TagItem(WA_IDCMP,       IDCMP_CLOSEWINDOW or IDCMP_GADGETUP or LISTVIEWIDCMP);
  WinTags[4]:=TagItem(WA_Flags,       WFLG_DEPTHGADGET or WFLG_DRAGBAR or WFLG_ACTIVATE or WFLG_CLOSEGADGET);
  WinTags[5]:=TagItem(WA_Title,       Long(^WinTitle));
  WinTags[6]:=TagItem(WA_Gadgets,     Long(FGad));
  WinTags[7]:=TagItem(WA_Left,        Win^.LeftEdge+Win^.Width shr 1-WinTags[1].ti_Data shr 1);
  WinTags[8]:=TagItem(WA_Top,         Win^.TopEdge+Win^.Height shr 1-WinTags[2].ti_Data shr 1);
  WinTags[9].ti_Tag:=TAG_DONE;
  NGad[1]:=NewGadget(16+TLn('Adresse:'),PubScr^.BarHeight+4,WinTags[1].ti_Data-24-TLn('Adresse:'),
                     PubScr^.Font^.ta_YSize+4,'Adresse:',PubScr^.Font,1,PLACETEXT_LEFT,VInfo,Nil);
  NGad[2]:=NewGadget(8,PubScr^.BarHeight+11+PubScr^.Font^.ta_YSize,WinTags[1].ti_Data-16,8*PubScr^.Font^.ta_YSize+4,Nil,PubScr^.Font,2,0,VInfo,Nil);
  NGad[3]:=NewGadget(8,PubScr^.BarHeight+20+9*PubScr^.Font^.ta_YSize,TLn('Zurck')+50,PubScr^.Font^.ta_YSize+4,'Ok',PubScr^.Font,3,0,VInfo,Nil);
  NGad[4]:=NewGadget(WinTags[1].ti_Data-58-TLn('Zurck'),PubScr^.BarHeight+20+9*PubScr^.Font^.ta_YSize,TLn('Zurck')+50,PubScr^.Font^.ta_YSize+4,'Zurck',PubScr^.Font,4,0,VInfo,Nil);
  Txt:=Dez2Hex(Long(StructAddress));
  Tags[1]:=TagItem(GTST_String,            Long(^Txt));
  Tags[2]:=TagItem(STRINGA_Justification,  GACT_STRINGRIGHT);
  Tags[3]:=TagItem(GTST_MaxChars,          8);
  Tags[4].ti_Tag:=TAG_DONE;
  IGad:=CreateGadgetA(STRING_KIND,FGad,^NGad[1],^Tags);
  Tags[1]:=TagItem(GTLV_Labels,            Long(^Structs));
  Tags[2]:=TagItem(GTLV_ShowSelected,      0);
  Tags[3].ti_Tag:=TAG_DONE;
  Gad:=CreateGadgetA(LISTVIEW_KIND,IGad,^NGad[2],^Tags);
  Gad:=CreateGadgetA(BUTTON_KIND,Gad,^NGad[3],Nil);
  Gad:=CreateGadgetA(BUTTON_KIND,Gad,^NGad[4],Nil);
  WinReq:=OpenWindowTagList(Nil, ^WinTags);
  If Win=Nil Then
    ErrorRequest('Konnte Fenster nicht ffnen.',true);
  GT_RefreshWindow(WinReq, Nil);
  SInfo:=IGad^.SpecialInfo;  LVAkt:=-1;
  ok:=false;  Ende:=false;
  Repeat
    MsgReq:=Wait_Port(WinReq^.UserPort);
    MsgReq:=GT_GetIMsg(WinReq^.UserPort);
    Case MsgReq^.Class Of
      IDCMP_CLOSEWINDOW: Ende:=true;
      IDCMP_GADGETUP: Begin
                        Gad:=MsgReq^.IAddress;
                        Case Gad^.GadgetID Of
                          2: LVAkt:=MsgReq^.Code;
                          3: Begin
                               ok:=true;
                               Ende:=true;
                             End;
                          4: Ende:=true;
                        Else;
                        End;
                      End;
    Else;
    End;
    GT_ReplyIMsg(MsgReq);
  Until Ende;
  CloseWindow(WinReq);
  If ok Then Begin
    SInfo:=IGad^.SpecialInfo;
    Txt:=SInfo^.Buffer;
    StructAddress:=Ptr(DecryptHex(Txt));
    If LVAkt<>-1 Then Begin
      myStruct:=p_Struct(Structs.lh_Head);
      dum:=0;
      While (myStruct^.Node.ln_Succ<>Nil) and (dum<LVAkt) Do Begin
        Inc(dum);
        myStruct:=p_Struct(myStruct^.Node.ln_Succ);
      End;
    End Else
      myStruct:=Ptr($ffffffff);
    AndereStruktur:=myStruct;
  End;
  FreeGadgets(GadLst);
END;

{Die folgenden Routinen werden aufgerufen, wenn Sie auf die Funktionsgadgets drcken}

PROCEDURE AssignTools(ToolNum :Long);

BEGIN
  If ((AktNode=Nil) or (AktNode^.Address=Nil)) and (ToolNum<>1) Then
    Exit;
  Case ToolNum Of
    1: AddAssign;
    2: If (Not Fragen) or (Fragen) and (Frage('Wollen Sie den Assign|wirklich entfernen?')) Then Begin
         If AssignLock(AktNode^.ObjName,0)=0 Then;
         AktNode:=Nil;
       End;
  Else;
  End;
END;


PROCEDURE FontTools(ToolNum :Long);

VAR     myFont  :^TextFont;

BEGIN
  If ((AktNode=Nil) or (AktNode^.Address=Nil)) and (ToolNum<>1) Then
    Exit;
  myFont:=AktNode^.Address;
  Case ToolNum Of
    1: Begin
         AddFont;
         AktNode:=Nil;
       End;
    5: If (Not Fragen) or (Fragen) and (Frage('Wollen Sie den Font|wirklich schlieen?')) Then Begin
         For dum:=1 to myFont^.tf_Accessors Do
           CloseFont(myFont);
         RemFont(myFont);
         AktNode:=Nil;
       End;
  Else;
  End;
END;


PROCEDURE PortTools(ToolNum :Long);

BEGIN
  Case ToolNum Of
    2: If (Not Fragen) or (Fragen) and (Frage('Wollen Sie den Port|wirklich entfernen?')) Then Begin
         Remove(^AktNode^.Node);
         RemPort(AktNode^.Address);
         DeleteMsgPort(AktNode^.Address);
         Dispose(AktNode);
         AktNode:=Nil;
       End;
    4: ChangePriority;
  Else;
  End;
END;


PROCEDURE IntrTools(ToolNum :Long);

BEGIN
  Case ToolNum Of
    2: If (Not Fragen) or (Fragen) and (Frage('Wollen Sie den Interrupt|wirklich entfernen?')) Then Begin
         Remove(^AktNode^.Node);
         RemIntServer(AktNode^.Node.ln_Type,AktNode^.Address);
         Dispose(AktNode);
         AktNode:=Nil;
       End;
    4: ChangePriority;
  Else;
  End;
END;


PROCEDURE TaskTools(ToolNum :Long);

VAR     ExBase  :^ExecBase;
        TaskFnd :^Task;
        ok      :Boolean;

BEGIN
  ExBase:=SysBase;
  If DispMode=1 Then           {<- Ex-EnforcerHit}
    TaskFnd:=AktNode^.Address
  Else
    TaskFnd:=WinTask;
  If (FindTask(TaskFnd^.tc_Node.ln_Name)=Nil) and (ToolNum<>6) Then Begin
    AktNode:=Nil;
    Exit;
  End;
  Case ToolNum Of
    2: If (Not Fragen) or (Fragen) and (Frage('Wollen Sie den Task|wirklich entfernen?')) Then Begin
         Remove(^AktNode^.Node);
         If (TWinRel) and (RemoveWindows(TaskFnd,false)) and (Frage('Wollen Sie die dem Task angehrenden|Fenster schliessen lassen?')) Then
           ok:=RemoveWindows(TaskFnd,true)
         Else
           RemTask(TaskFnd);
         Dispose(AktNode);
         AktNode:=Nil;
       End;
    3: SetSignal;
    4: ChangePriority;
    6: If (TaskFnd^.tc_State=8) Then Begin
         Disable;
         Remove(^TaskFnd^.tc_Node);
         Insert(^ExBase^.TaskReady,^TaskFnd^.tc_Node,Nil);
         TaskFnd^.tc_State:=3;
         Enable;
         AktNode:=Nil;
       End Else Begin
         Disable;
         Remove(^TaskFnd^.tc_Node);
         Insert(^ExBase^.IntrList,^TaskFnd^.tc_Node,Nil);
         TaskFnd^.tc_State:=8;
         Enable;
         AktNode:=Nil;
       End;
    7: Begin
         DispMode:=14;
         {WinTask:=AktNode^.Address;}
       End;
  Else;
  End;
END;


PROCEDURE SysTools(ToolNum :Long);

BEGIN
  If (AktNode=Nil) or (AktNode^.Address=Nil) Then
    Exit;
  Case ToolNum Of
    4: ChangePriority;
  Else;
  End;
END;


PROCEDURE LibsTools(ToolNum :Long);

VAR     myLib   :p_Library;

BEGIN
  Case ToolNum Of
    2: If (Not Fragen) or (Fragen) and (Frage('Sind Sie sicher?')) Then Begin
         Remove(^AktNode^.Node);
         myLib:=AktNode^.Address;
           myLib^.lib_OpenCnt:=0;
         If DispMode=4 Then
           CloseLibrary(AktNode^.Address)
         Else
           myLib^.lib_OpenCnt:=0;
         If DispMode=5 Then
           RemResource(AktNode^.Address);
         If DispMode=6 Then
           RemDevice(AktNode^.Address);
         Dispose(AktNode);
         AktNode:=Nil;
       End;
    4: ChangePriority;
  Else;
  End;
END;


PROCEDURE ScrTools(ToolNum :Long);

VAR     ScrPtr  :^Screen;
        WinPtr  :^Window;
        WinSave :Ptr;

BEGIN
  Case ToolNum Of
    1: Begin
         AddScreen;
         AktNode:=Nil
       End;
    5: If (Fragen) and (Frage('Wollen Sie den Screen|wirklich schliessen?')) Then Begin
         ScrPtr:=AktNode^.Address;
         WinPtr:=ScrPtr^.FirstWindow;
         AktNode:=Nil;
         If (Not CloseScreen(ScrPtr)) and (WinPtr<>Nil) Then Begin
           If Frage('Sollen die auf dem Screen befindlichen Fenster geschlossen werden') Then Begin
             While WinPtr<>Nil Do Begin
               WinSave:=WinPtr^.NextWindow;
               WinPtr^.UserPort:=Nil;
               ModifyIDCMP(WinPtr, 0);
               CloseWindow(WinPtr);
               WinPtr:=WinSave;
             End;
             If Not CloseScreen(ScrPtr) Then
               ErrorRequest('Konnte Screen nicht schlieen.',false);
           End;
         End;
       End;
    7: Begin
         DispMode:=14;
         WinTask:=Nil;
       End;
  Else;
  End;
END;


PROCEDURE WinTools(ToolNum :Long);

VAR     WinPtr  :^Window;
        myNode  :^Node;
        ok      :Boolean;

BEGIN
  WinPtr:=AktNode^.Address;
  Case ToolNum Of
    5: If (Not Fragen) or (Frage('Wollen Sie das Fenster|wirklich schlieen?')) Then Begin
         myNode:=WinPtr^.UserPort^.mp_SigTask;
         If (TWinRel) and (myNode<>Nil) and (FindTask(myNode^.ln_Name)<>Nil) and (Frage('Wollen Sie alle dem Task '+TaskNam(^myNode^)+'|angehrenden Fenster schlieen?')) Then
           ok:=RemoveWindows(WinPtr^.UserPort^.mp_SigTask,true)
         Else Begin
           If (FindTask(myNode^.ln_Name)<>Nil) Then
             CloseWindow(WinPtr)
           Else Begin
             WinPtr^.UserPort:=Nil;
             ModifyIDCMP(WinPtr, 0);
             CloseWindow(WinPtr);
           End;
         End;
         AktNode:=Nil;
       End;
  Else;
  End;
END;

{Die folgenden Funktionen generieren die verschiedenen Anzeigen}

PROCEDURE GetWindowList;

VAR     Count   :Integer;
        WinPtr  :^Window;
        IntBas  :p_IntuitionBase;
        ILock   :Long;


  PROCEDURE NewListEntry(WinPtr :p_Window);

  BEGIN
    New(AktNode);
    Inc(Count);
    AktNode^.ObjName:=WinPtr^.Title;
    AktNode^.Name:=Dez2Hex(Long(WinPtr))+' '+FormText(IntStr(WinPtr^.LeftEdge),4,false)+','+FormText(IntStr(WinPtr^.TopEdge),4,false)+' ';
    AktNode^.Name:=AktNode^.Name+FormText(IntStr(WinPtr^.Width),4,false)+','+FormText(IntStr(WinPtr^.Height),4,false)+' ';
    AktNode^.Name:=AktNode^.Name+Dez2Hex(WinPtr^.IDCMPFlags)+' '+Dez2Hex(WinPtr^.Flags);
    AktNode^.Name:=AktNode^.Name+' '+WinPtr^.Title;
    AktNode^.Address:=WinPtr;
    AktNode^.Node.ln_Name:=AktNode^.Name;
    AddTail(^Liste, ^AktNode^.Node);
  END;

BEGIN
  Count:=0;
  If WinTask<>Nil Then Begin
    IntBas:=IntuitionBase;
    ILock:=LockIBase(0);
    ScrPtr:=IntBas^.FirstScreen;
  End;
  If ScrPtr<>Nil Then
    Repeat
      WinPtr:=ScrPtr^.FirstWindow;
      While WinPtr<>Nil Do Begin
        If WinTask=Nil Then
          NewListEntry(WinPtr)
        Else If WinPtr^.UserPort^.mp_SigTask=WinTask Then
          NewListEntry(WinPtr);
        WinPtr:=WinPtr^.NextWindow;
      End;
      If WinTask<>Nil Then
        ScrPtr:=ScrPtr^.NextScreen;
    Until (WinTask=Nil) or (WinTask<>Nil) and (ScrPtr=Nil);
  If WinTask<>Nil Then Begin
    UnlockIBase(ILock);
    StatusText:=IntStr(Count)+' Window(s) von Task '+TaskNam(WinTask)+' geffnet.';
  End Else
    StatusText:=IntStr(Count)+' Window(s) offen auf Screen '+ScrPtr^.DefaultTitle+'.';
END;


PROCEDURE GetIntrList;

VAR     ExBase  :^ExecBase;
        Count   :Integer;
        Intr    :p_Interrupt;
        IVec    :p_IntVector;
        IntTyp  :Long;

  PROCEDURE NewListEntry(Intr :p_Interrupt);

  VAR   Types   :Typen;

  BEGIN
    New(AktNode);
    Inc(Count);
    Types:=Typen('unknown','task','interrupt','device','msgport','message','freemsg','replymsg','resource',
                 'library','memory','softint','font','process','semaphore','signalsem','bootnode');
    AktNode^.Node.ln_Pri:=Intr^.is_Node.ln_Pri;
    AktNode^.Node.ln_Type:=dum;
    AktNode^.ObjName:=Intr^.is_Node.ln_Name;
    AktNode^.Name:=Dez2Hex(Long(Intr))+' '+FormText(IntStr(Intr^.is_Node.ln_Pri),4,false)+' '+Dez2Hex(Long(Intr^.is_Data))+' ';
    AktNode^.Name:=AktNode^.Name+Dez2Hex(Long(Intr^.is_Code))+' '+FormText(IntStr(dum),3,false)+' ';
    Case dum Of
      0: AktNode^.Name:=AktNode^.Name+'Serial Out ';
      1: AktNode^.Name:=AktNode^.Name+'Disk Block ';
      2: AktNode^.Name:=AktNode^.Name+'SoftInt    ';
      3: AktNode^.Name:=AktNode^.Name+'CIA-A/INT2 ';
      4: AktNode^.Name:=AktNode^.Name+'Copper     ';
      5: AktNode^.Name:=AktNode^.Name+'Vert. Beam ';
      6: AktNode^.Name:=AktNode^.Name+'Blitter    ';
      7: AktNode^.Name:=AktNode^.Name+'Audio-Ch.2 ';
      8: AktNode^.Name:=AktNode^.Name+'Audio-Ch.0 ';
      9: AktNode^.Name:=AktNode^.Name+'Audio-Ch.3 ';
      10: AktNode^.Name:=AktNode^.Name+'Audio-Ch.1 ';
      11: AktNode^.Name:=AktNode^.Name+'Serial In  ';
      12: AktNode^.Name:=AktNode^.Name+'Disk Sync  ';
      13: AktNode^.Name:=AktNode^.Name+'CIA-B/INT6 ';
      14: AktNode^.Name:=AktNode^.Name+'INTEN      ';
      15: AktNode^.Name:=AktNode^.Name+'NMI        ';
    Else
      AktNode^.Name:=AktNode^.Name+'unknown    ';
    End;
    If IntTyp and (1 shl dum)=0 Then
      AktNode^.Name:=AktNode^.Name+'hand '
    Else
      AktNode^.Name:=AktNode^.Name+'serv ';
    AktNode^.Name:=AktNode^.Name+FormText(Types[Intr^.is_Node.ln_Type],9,true)+' '+AktNode^.ObjName;
    AktNode^.Node.ln_Name:=AktNode^.Name;
    AktNode^.Address:=Intr;
    AddTail(^Liste, ^AktNode^.Node);
  END;

BEGIN
  Count:=0;
  IntTyp:=%0010000000111000;
  ExBase:=SysBase;
  Disable;
  For dum:=0 to 15 Do Begin
    If IntTyp and (1 shl dum)=0 Then
      Intr:=^ExBase^.IntVects[dum].iv_Node^
    Else Begin
      Intr:=ExBase^.IntVects[dum].iv_Data;
      Intr:=^Intr^.is_Node.ln_Succ^;
    End;
    If Intr<>Nil Then Begin
      Repeat
        NewListEntry(Intr);
        Intr:=^Intr^.is_Node.ln_Succ^;
      Until (Intr^.is_Node.ln_Succ=Nil) or (Intr=Nil);
    End;
  End;
  Enable;
  StatusText:=IntStr(Count)+' Interrupts im System.';
END;


FUNCTION FormMem(Zahl,MaxChar :Long;Links :Boolean) : AppString;

VAR   Spaces  :AppString;
      Txt     :AppString;

BEGIN
  Txt:='B';
  If Length(IntStr(Zahl))>MaxChar-1 Then Begin
    Zahl:=Zahl Div 1024;
    Txt:='kB';
    If Length(IntStr(Zahl))>MaxChar-2 Then Begin
      Zahl:=Zahl Div 1024;
      Txt:='MB';
    End;
  End;
  Txt:=IntStr(Zahl)+Txt;
  Spaces:='                        ';
  If Length(Txt)>MaxChar Then
    Txt:=Copy(Txt, 1,MaxChar)
  Else Begin
    If Links Then
      Txt:=Txt+Copy(Spaces,1,MaxChar-Length(Txt))
    Else
      Txt:=Copy(Spaces,1,MaxChar-Length(Txt))+Txt;
  End;
  FormMem:=Txt;
END;


PROCEDURE GetMemList;

VAR     MHeader :p_MemHeader;
        ExBase  :^ExecBase;
        MemFree :Long;
        MemTot  :Long;

  PROCEDURE NewListEntry(MHeader :p_MemHeader);

  BEGIN
    New(AktNode);
    AktNode^.Node.ln_Pri:=MHeader^.mh_Node.ln_Pri;
    AktNode^.ObjName:=MHeader^.mh_Node.ln_Name;
    AktNode^.Name:='           '+Dez2Hex(Long(MHeader))+' '+FormText(IntStr(MHeader^.mh_Node.ln_Pri),4,false)+' '+Dez2Hex(Long(MHeader^.mh_Lower))+' '+Dez2Hex(Long(MHeader^.mh_Upper));
    AktNode^.Name:=AktNode^.Name+' '+FormMem((Long(MHeader^.mh_Upper)-Long(MHeader^.mh_Lower)),6,false)+' '+FormMem(MHeader^.mh_Free,6,false)+' '+FormText(AktNode^.ObjName,18,true);
    MemTot:=MemTot+Long(MHeader^.mh_Upper)-Long(MHeader^.mh_Lower);
    MemFree:=MemFree+MHeader^.mh_Free;
    AktNode^.Address:=MHeader;
    AktNode^.Node.ln_Name:=AktNode^.Name;
    AddTail(^Liste, ^AktNode^.Node);
  END;

BEGIN
  ExBase:=SysBase;
  MemTot:=0;  MemFree:=0;
  MHeader:=^ExBase^.MemList.lh_Head^;
  AddText('Speicher:  Adresse  Pri  Lower    Upper    Gre  Frei   Name',false);
  AddText('           --------------------------------------------------------------------------------',false);
  While MHeader^.mh_Node.ln_Succ<>Nil Do Begin
    NewListEntry(MHeader);
    MHeader:=^MHeader^.mh_Node.ln_Succ^;
  End;
  AddText('           --------------------------------------------------------------------------------',false);
  AddText('Total:                                     '+FormMem(MemTot,6,false)+' '+FormMem(MemFree,6,false),false);
END;


PROCEDURE GetBoardList;

VAR     ConDev  :^ConfigDev;
        Count   :Long;

BEGIN
  AddText('Boards:  Adresse  Gre  Typ                            Prod. Hersteller',false);
  AddText('         ----------------------------------------------------------------------------------',false);
  ConDev:=Nil;  ConDev:=FindConfigDev(Nil,-1,-1);  Count:=0;
  While ConDev<>Nil Do Begin
    Inc(Count);  New(AktNode);
    AktNode^.ObjName:='';
    AktNode^.Name:='         '+Dez2Hex(Long(ConDev^.cd_BoardAddr))+' '+FormMem(ConDev^.cd_BoardSize,6,false);
    If (ConDev^.cd_Rom.er_Flags And ERFF_ZORRO_III)>0 Then
      AktNode^.ObjName:='Zorro-III,'
    Else
      AktNode^.ObjName:='Zorro-II,';

    If (ConDev^.cd_Rom.er_Type And ERTF_MEMLIST)>0 Then
      AktNode^.ObjName:=AktNode^.ObjName+'RAM-Karte,'
    Else If (ConDev^.cd_Rom.er_Manufacturer=2102) and (ConDev^.cd_Rom.er_Product=1) Then
      AktNode^.ObjName:=AktNode^.ObjName+'SCSI-Hostadpt.,'
    Else If (ConDev^.cd_Rom.er_Type=$d1) Then
      AktNode^.ObjName:=AktNode^.ObjName+'HD???,';
    AktNode^.ObjName:=AktNode^.ObjName+'($'+Copy(Dez2Hex(ConDev^.cd_Rom.er_Type),7,2)+'/$'+Copy(Dez2Hex(ConDev^.cd_Rom.er_Flags),7,2)+')';
    AktNode^.Name:=AktNode^.Name+' '+FormText(AktNode^.ObjName,30,true)+' $'+Copy(Dez2Hex(ConDev^.cd_Rom.er_Product),7,2)+'  ';
    AktNode^.ObjName:='unbekannt';
    Case ConDev^.cd_Rom.er_Manufacturer Of
      2011: AktNode^.ObjName:='Test-Karte';
      2102: AktNode^.ObjName:='Nexus';
    Else;
    End;
    AktNode^.ObjName:=AktNode^.ObjName+' ('+IntStr(ConDev^.cd_Rom.er_Manufacturer)+')';
    AktNode^.Name:=AktNode^.Name+' '+AktNode^.ObjName;
    AktNode^.ObjName:='';
    AktNode^.Node.ln_Name:=AktNode^.Name;
    AddTail(^Liste, ^AktNode^.Node);
    ConDev:=FindConfigDev(ConDev,-1,-1);
  End;
  If Count>0 Then
    AddText('         --------------------------------------------------------------------------------',false);
  AddText('         '+IntStr(Count)+' Board(s) im System.',false);
END;


PROCEDURE GetSystemInfo;

VAR     ExBase  :^ExecBase;
        Txt     :AppString;
        num     :^Long;

BEGIN
  ExBase:=SysBase;
  If (ExBase^.AttnFlags And 8)>0 Then
    Txt:='68040'
  Else If (ExBase^.AttnFlags And 4)>0 Then
    Txt:='68030'
  Else If (ExBase^.AttnFlags And 2)>0 Then
    Txt:='68020'
  Else If (ExBase^.AttnFlags And 1)>0 Then
    Txt:='68010'
  Else
    Txt:='68000';
  Txt:='Hauptprozessor:    '+Txt;
  AddText(Txt,false);
  AddText('',false);
  If (ExBase^.AttnFlags And 112)>64 Then
    AddText('Co-Prozessor:      68040 (mit 68881/82-Emulation)',false)
  Else If (ExBase^.AttnFlags And 112)=64 Then
    AddText('Co-Prozessor:      68040 (ohne 68881/82-Emulation)',false)
  Else If (ExBase^.AttnFlags And 32)>0 Then
    AddText('Co-Prozessor:      68882',false)
  Else If (ExBase^.AttnFlags And 16)>0 Then
    AddText('Co-Prozessor:      68881',false)
  Else
    AddText('Co-Prozessor:      keiner',false);
  If (GfxBase^.ChipRevBits0 And 32)>0 Then
    Txt:='NEUES CHIPSET!'
  Else If (GfxBase^.ChipRevBits0 And GFXF_AA_LISA)>0 Then
    Txt:='AA-Lisa'
  Else If (GfxBase^.ChipRevBits0 And GFXF_HR_DENISE)>0 Then
    Txt:='ECS-Denise'
  Else
    Txt:='standart Denise';
  If (GfxBase^.ChipRevBits0 And 32)>0 Then
    Txt:=Txt
  Else If (GfxBase^.ChipRevBits0 And GFXF_AA_ALICE)>0 Then
    Txt:=Txt+', AA-Alice'
  Else If (GfxBase^.ChipRevBits0 And GFXF_HR_AGNUS)>0 Then
    Txt:=Txt+', ECS-Agnus'
  Else
    Txt:=Txt+', standart Agnus';
  AddText('Customchips:       '+Txt,false);
  AddText('',false);
  AddText('Kickstart-Version: '+IntStr(ExBase^.LibNode.lib_Version)+'.'+IntStr(ExBase^.SoftVer),false);
  Txt:=IntStr(ExBase^.ex_EClockFrequency Div 100);
  Txt:=IntStr(ExBase^.ex_EClockFrequency Div 100000)+'.'+Copy(Txt,Length(Txt)-2,3)+' MHz';
  AddText('EClock-Frequenz:   '+Txt,false);
  AddText('',false);
  AddText('',false);
  If ExBase^.LastAlert[1]>0 Then Begin
    num:=Ptr($100);
    AddText('Letzte Guru-Meldung: '+Dez2Hex(num^)+'.'+Dez2Hex(ExBase^.LastAlert[1]),false);
    AddText('',false);
  End;
  GetMemList;
  AddText('',false);
  AddText('',false);
  GetBoardList;
  AddText('',false);
END;


PROCEDURE GetPortList;

VAR     Prt     :p_MsgPort;
        ExBase  :^ExecBase;
        Count   :Integer;

  PROCEDURE NewListEntry(Prt :p_MsgPort);

  VAR   PrtTask :p_Task;

  BEGIN
    New(AktNode);
    Inc(Count);
    AktNode^.Node.ln_Pri:=Prt^.mp_Node.ln_Pri;
    PrtTask:=Prt^.mp_SigTask;  AktNode^.ObjName:=Prt^.mp_Node.ln_Name;
    AktNode^.Name:=Dez2Hex(Long(Prt))+' '+FormText(IntStr(Prt^.mp_Node.ln_Pri),4,false)+' ';
    Case Prt^.mp_Flags Of
      0: AktNode^.Name:=AktNode^.Name+'Signal   ';
      1: AktNode^.Name:=AktNode^.Name+'SoftInt  ';
      2: AktNode^.Name:=AktNode^.Name+'Ignore   ';
      3: AktNode^.Name:=AktNode^.Name+'Action   ';
    Else
      AktNode^.Name:=AktNode^.Name+'unknown  ';
    End;
    AktNode^.Address:=Prt;
    AktNode^.Name:=AktNode^.Name+FormText(IntStr(Prt^.mp_SigBit),3,false)+' ';
    AktNode^.Name:=AktNode^.Name+'msgport '+FormText(AktNode^.ObjName,18,true);
    If (PrtTask<>Nil) and (FindTask(PrtTask^.tc_Node.ln_Name)<>Nil) Then
      AktNode^.Name:=AktNode^.Name+' '+TaskNam(PrtTask);
    AktNode^.Node.ln_Name:=AktNode^.Name;
    AddTail(^Liste, ^AktNode^.Node);
  END;

BEGIN
  Count:=0;
  ExBase:=SysBase;
  Disable;
  Prt:=^ExBase^.PortList.lh_Head^;
  While Prt^.mp_Node.ln_Succ<>Nil Do Begin
    NewListEntry(Prt);
    Prt:=^Prt^.mp_Node.ln_Succ^;
  End;
  Enable;
  StatusText:=IntStr(Count)+' Ports im System.';
END;


PROCEDURE GetLibsList(Mode :Long);

VAR     Lib     :p_Library;
        ExBase  :^ExecBase;
        Count   :Integer;

  PROCEDURE NewListEntry(LibPtr :p_Library);

  VAR     Types   :Typen;

  BEGIN
    New(AktNode);
    Inc(Count);
    Types:=Typen('unknown','task','interrupt','device','msgport','message','freemsg','replymsg','resource',
                 'library','memory','softint','font','process','semaphore','signalsem','bootnode');
    AktNode^.Node.ln_Pri:=LibPtr^.lib_Node.ln_Pri;
    AktNode^.ObjName:=LibPtr^.lib_Node.ln_Name;
    AktNode^.Name:=Dez2Hex(Long(LibPtr))+' '+FormText(IntStr(LibPtr^.lib_Node.ln_Pri),4,false)+' '+FormText(IntStr(LibPtr^.lib_Version),4,false);
    AktNode^.Name:=AktNode^.Name+'.'+FormText(IntStr(LibPtr^.lib_Revision),4,true)+' '+FormText(IntStr(LibPtr^.lib_OpenCnt),5,false)+' ';
    AktNode^.Name:=AktNode^.Name+FormText(IntStr(LibPtr^.lib_NegSize),5,false)+' '+FormText(IntStr(LibPtr^.lib_PosSize),5,false)+' ';
    AktNode^.Name:=AktNode^.Name+FormText(Types[LibPtr^.lib_Node.ln_Type],8,true)+' '+LibPtr^.lib_Node.ln_Name;
    AktNode^.Address:=LibPtr;
    AktNode^.Node.ln_Name:=AktNode^.Name;
    AddTail(^Liste, ^AktNode^.Node);
  END;

BEGIN
  Count:=0;
  ExBase:=SysBase;
  Disable;
  Case Mode Of
    4: Lib:=^ExBase^.LibList.lh_Head^;
    5: Lib:=^ExBase^.ResourceList.lh_Head^;
    6: Lib:=^ExBase^.DeviceList.lh_Head^;
  End;

  While Lib^.lib_Node.ln_Succ<>Nil Do Begin
    NewListEntry(Lib);
    Lib:=^Lib^.lib_Node.ln_Succ^;
  End;
  Enable;
  Case Mode Of
    4: StatusText:=IntStr(Count)+' Libraries im System.';
    5: StatusText:=IntStr(Count)+' Resource(s) im System.';
    6: StatusText:=IntStr(Count)+' Device(s) im System.';
  End;
END;


PROCEDURE GetResidents;

VAR     Res     :^Ptr;
        ExBase  :^ExecBase;
        Count   :Integer;

  PROCEDURE NewListEntry(ResPtr :p_Resident);

  VAR     Types   :Typen;

  BEGIN
    New(AktNode);
    Inc(Count);
    Types:=Typen('unknown','task','interrupt','device','msgport','message','freemsg','replymsg','resource',
                 'library','memory','softint','font','process','semaphore','signalsem','bootnode');
    AktNode^.Node.ln_Pri:=ResPtr^.rt_Pri;
    If ResPtr^.rt_IdString='' Then
      AktNode^.ObjName:=ResPtr^.rt_Name
    Else
      AktNode^.ObjName:=ResPtr^.rt_IdString;
    While (AktNode^.ObjName[Length(AktNode^.ObjName)]=chr(10)) or (AktNode^.ObjName[Length(AktNode^.ObjName)]=chr(13)) Do
      AktNode^.ObjName:=Copy(AktNode^.ObjName,1,Length(AktNode^.ObjName)-1);
    AktNode^.Name:=Dez2Hex(Long(ResPtr))+' '+FormText(IntStr(ResPtr^.rt_Pri),4,false)+' '+FormText(IntStr(ResPtr^.rt_Version),7,false);
    AktNode^.Name:=AktNode^.Name+'   $'+Copy(Dez2Hex(ResPtr^.rt_Flags),7,2);
    AktNode^.Name:=AktNode^.Name+' '+FormText(Types[ResPtr^.rt_Type],10,true)+' '+AktNode^.ObjName;
    AktNode^.ObjName:=ResPtr^.rt_Name;
    AktNode^.Address:=ResPtr;
    AktNode^.Node.ln_Name:=AktNode^.Name;
    AddTail(^Liste, ^AktNode^.Node);
  END;

BEGIN
  Count:=0;
  ExBase:=SysBase;
  Res:=ExBase^.ResModules;
  While Res^<>Nil Do Begin
    NewListEntry(Res^);
    Res:=Ptr(Long(Res)+4);
  End;
  StatusText:=IntStr(Count)+' Residents im System.';
END;


PROCEDURE GetAssignList;

VAR     DosLib  :p_DosLibrary;
        DosInfo :p_DosInfo;
        DevLst  :p_DeviceList;
        OldLock :BPTR;
        Count   :Long;

  PROCEDURE NewEntry(DevLst :p_DeviceList);

  BEGIN
    New(AktNode);
    Inc(Count);
    AktNode^.ObjName:=BCPLString(Ptr(DevLst^.dl_Name shl 2));
    AktNode^.Name:=Dez2Hex(Long(DevLst))+'   '+FormText(AktNode^.ObjName,18,true)+' ';
    OldLock:=CurrentDir(DevLst^.dl_Lock);
    FullName(DevLst^.dl_Lock, AktNode^.Name);
    OldLock:=CurrentDir(OldLock);
    If AktNode^.Name[Length(AktNode^.Name)]='/' Then
      AktNode^.Name:=Copy(AktNode^.Name,1,Length(AktNode^.Name)-1);
    AktNode^.Address:=DevLst;
    AktNode^.Node.ln_Name:=AktNode^.Name;
    AddTail(^Liste, ^AktNode^.Node);
  END;

BEGIN
  Count:=0;
  DosLib:=DosBase;
  DosInfo:=Ptr(DosLib^.dl_Root^.rn_Info shl 2);
  DevLst:=Ptr(DosInfo^.di_DevInfo shl 2);
  If DevLst<>Nil Then Begin
    Repeat
      If DevLst^.dl_Type=1 Then
        NewEntry(DevLst);
      DevLst:=Ptr(DevLst^.dl_Next shl 2);
    Until DevLst=Nil;
  End;
  StatusText:=IntStr(Count)+' Assign(s) im System.';
END;


PROCEDURE GetScreenList;

VAR     IntBas  :p_IntuitionBase;
        Count   :Integer;
        ILock   :Long;
        ScrPtr  :^Screen;


  PROCEDURE NewListEntry(ScrPtr :p_Screen);

  BEGIN
    New(AktNode);
    Inc(Count);
    AktNode^.ObjName:=ScrPtr^.DefaultTitle;
    AktNode^.Name:=Dez2Hex(Long(ScrPtr))+' '+FormText(IntStr(ScrPtr^.LeftEdge),4,false)+','+FormText(IntStr(ScrPtr^.TopEdge),4,false)+' ';
    AktNode^.Name:=AktNode^.Name+FormText(IntStr(ScrPtr^.Width),4,false)+','+FormText(IntStr(ScrPtr^.Height),4,false)+' ';
    AktNode^.Name:=AktNode^.Name+FormText(IntStr(ScrPtr^.BitMap.Depth),3,false)+' '+Copy(Dez2Hex(GetVPModeID(^ScrPtr^.ViewPort)),3,6)+' ';
    If (ScrPtr^.Flags and $f)=$f Then
      AktNode^.Name:=AktNode^.Name+'custom'+' '+ScrPtr^.DefaultTitle
    Else If (ScrPtr^.Flags and $1)=$1 Then
      AktNode^.Name:=AktNode^.Name+'wbench'+' '+ScrPtr^.DefaultTitle
    Else If (ScrPtr^.Flags and $2)=$2 Then
      AktNode^.Name:=AktNode^.Name+'pubscr'+' '+ScrPtr^.DefaultTitle
    Else
      AktNode^.Name:=AktNode^.Name+'unknwn'+' '+ScrPtr^.DefaultTitle;
    AktNode^.Address:=ScrPtr;
    AktNode^.Node.ln_Name:=AktNode^.Name;
    AddTail(^Liste, ^AktNode^.Node);
  END;

BEGIN
  Count:=0;
  IntBas:=IntuitionBase;
  ILock:=LockIBase(0);
  ScrPtr:=IntBas^.FirstScreen;
  While ScrPtr<>Nil Do Begin
    NewListEntry(ScrPtr);
    ScrPtr:=ScrPtr^.NextScreen;
  End;
  UnlockIBase(ILock);
  StatusText:=IntStr(Count)+' Screen(s) offen.';
END;


PROCEDURE GetFontList;

VAR     myFont  :p_TextFont;
        Count   :Long;

  PROCEDURE NewListEntry(myFont :p_TextFont);

  BEGIN
    New(AktNode);
    Inc(Count);
    AktNode^.ObjName:=myFont^.tf_Message.mn_Node.ln_Name;
    AktNode^.Name:=Dez2Hex(Long(myFont))+'  '+FormText(IntStr(myFont^.tf_XSize),5,false)+' '+FormText(IntStr(myFont^.tf_YSize),5,false)+' ';
    AktNode^.Name:=AktNode^.Name+FormText(IntStr(myFont^.tf_BaseLine),8,false)+'    $'+Copy(Dez2Hex(myFont^.tf_LoChar),7,2)+'    $'+Copy(Dez2Hex(myFont^.tf_HiChar),7,2);
    AktNode^.Name:=AktNode^.Name+' '+FormText(IntStr(myFont^.tf_Accessors),5,false)+' '+Dez2Hex(Long(myFont^.tf_CharData))+' '+AktNode^.ObjName;
    AktNode^.Address:=myFont;
    AktNode^.Node.ln_Name:=AktNode^.Name;
    AddTail(^Liste, ^AktNode^.Node);
  END;

BEGIN
  Count:=0;
  myFont:=^GfxBase^.TextFonts.lh_Head^;
  While myFont^.tf_Message.mn_Node.ln_Succ<>Nil Do Begin
    NewListEntry(myFont);
    myFont:=^myFont^.tf_Message.mn_Node.ln_Succ^;
  End;
  StatusText:=IntStr(Count)+' Font(s) offen.';
END;


PROCEDURE GetTaskList;

TYPE    Stat  = Array[0..8] of String[10];

VAR     TaskFnd :^Task;
        ExBase  :^ExecBase;
        Count   :Integer;

  PROCEDURE NewTaskEntry(TaskFnd :p_Task);

  VAR     Status  :Stat;
          Types   :Typen;
          Code    :String[6];

  BEGIN
    New(AktNode);
    Code:='---- ';
    Inc(Count);
    If (TaskFnd^.tc_ExceptCode<>Nil) Then Code[1]:='E';
    If (TaskFnd^.tc_TrapCode  <>Nil) Then Code[2]:='T';
    If (TaskFnd^.tc_Switch    <>Nil) Then Code[3]:='S';
    If (TaskFnd^.tc_Launch    <>Nil) Then Code[4]:='L';
    Status:=Stat('invalid','added','run','ready','wait','except','removed','error','frozen');
    Types:=Typen('unknown','task','interrupt','device','msgport','message','freemsg','replymsg','resource',
                 'library','memory','softint','font','process','semaphore','signalsem','bootnode');
    AktNode^.ObjName:=TaskNam(TaskFnd);
    dum:=Long(TaskFnd^.tc_SPUpper)-Long(TaskFnd^.tc_SPLower);
    AktNode^.Node.ln_Pri:=TaskFnd^.tc_Node.ln_Pri;
    AktNode^.Name:=Dez2Hex(Long(TaskFnd))+FormText(IntStr(AktNode^.Node.ln_Pri),5,false)+FormText(IntStr(dum),6,false)+' '+Dez2Hex(Long(TaskFnd^.tc_SigWait))+' ';
    AktNode^.Name:=AktNode^.Name+FormText(Status[TaskFnd^.tc_State],6,true)+'  '+Code+FormText(Types[TaskFnd^.tc_Node.ln_Type],8,true)+' '+AktNode^.ObjName;
    AktNode^.Address:=TaskFnd;
    AktNode^.Node.ln_Name:=AktNode^.Name;
    AddTail(^Liste, ^AktNode^.Node);
  END;


BEGIN
  ExBase:=SysBase;
  ExBase^.IntrList.lh_Type:=NT_TASK;
  Count:=0;

  Disable;
  TaskFnd:=ExBase^.ThisTask;
  NewTaskEntry(TaskFnd);
  TaskFnd:=^ExBase^.TaskReady.lh_Head^;
  While TaskFnd^.tc_Node.ln_Succ<>Nil Do Begin
    NewTaskEntry(TaskFnd);
    TaskFnd:=^TaskFnd^.tc_Node.ln_Succ^;
  End;
  TaskFnd:=^ExBase^.TaskWait.lh_Head^;
  While TaskFnd^.tc_Node.ln_Succ<>Nil Do Begin
    NewTaskEntry(TaskFnd);
    TaskFnd:=^TaskFnd^.tc_Node.ln_Succ^;
  End;
  TaskFnd:=^ExBase^.IntrList.lh_Head^;
  While TaskFnd^.tc_Node.ln_Succ<>Nil Do Begin
    NewTaskEntry(TaskFnd);
    TaskFnd:=^TaskFnd^.tc_Node.ln_Succ^;
  End;
  Enable;
  StatusText:=IntStr(Count)+' Task(s) im System.';
END;

{Die folgenden Funktionen sind fr den Strukturmodus}

FUNCTION GetLongestName(myStruct :p_Struct) : Integer;

BEGIN
  AktStructTyp:=p_StructTyp(myStruct^.Entrys.lh_Head);
  dum:=0;
  While AktStructTyp^.Node.ln_Succ<>Nil Do Begin
    If dum<Length(AktStructTyp^.Name) Then
      dum:=Length(AktStructTyp^.Name);
    AktStructTyp:=p_StructTyp(AktStructTyp^.Node.ln_Succ);
  End;
  GetLongestName:=dum;
END;


FUNCTION GetMemData(Adresse :Ptr;Typ :Byte) : Long;

VAR     pByte   :^Byte;
        pShort  :^Short;
        pInt    :^Integer;
        pWord   :^Word;
        pLong   :^Long;

BEGIN
  Case Typ Of
    STRUCT_UWORD: Begin
                    pWord:=Adresse;
                    GetMemData:=pWord^;
                  End;
    STRUCT_WORD: Begin
                   pInt:=Adresse;
                   GetMemData:=pInt^;
                 End;
    STRUCT_BYTE: Begin
                   pShort:=Adresse;
                   GetMemData:=pShort^;
                 End;
    STRUCT_UBYTE: Begin
                    pByte:=Adresse;
                    GetMemData:=pByte^;
                  End;
    STRUCT_LONG: Begin
                   pLong:=Adresse;
                   GetMemData:=pLong^;
                 End;
  Else;
  End;
END;


PROCEDURE GetMemView(AktPtr :Ptr);

VAR     Txt     :AppString;
        myMem,i :Long;
        Merk    :^Merker;
    Tags  :Array[1..2] of TagItem;

BEGIN
  If (AktStruct<>Nil) Then Begin
    New(Merk);
    Merk^.Struct:=AktStruct;
    Merk^.Address:=StructAddress;
    Tags[1]:=TagItem(GTLV_Top, Long(^Merk^.Top));
    Tags[2].ti_Tag:=TAG_DONE;
    If (IntuitionBase^.LibNode.lib_Version>38) and (GT_GetGadgetAttrsA(LstGad,Win,Nil,^Tags)=0) Then;
    AddTail(^MerkListe,^Merk^);
  End;
  StructAddress:=AktPtr;
  AktStruct:=Ptr($ffffffff);
  myMem:=Long(AktPtr);
  AddText('$'+Dez2Hex(myMem)+' Speichermonitor',false);
  AddText('--------------------------------------------------------------------------------------',false);
  For dum:=1 to 64 Do Begin
    Txt:='$'+Dez2Hex(myMem)+' -  '+Dez2Hex(GetMemData(Ptr(myMem),STRUCT_LONG))+'  '+Dez2Hex(GetMemData(Ptr(myMem+4),STRUCT_LONG));
    Txt:=Txt+'  '+Dez2Hex(GetMemData(Ptr(myMem+8),STRUCT_LONG))+'  '+Dez2Hex(GetMemData(Ptr(myMem+12),STRUCT_LONG))+'   ';
    For i:=1 to 16 Do Begin
      If GetMemData(Ptr(myMem+i),STRUCT_BYTE)<18 Then
        Txt:=Txt+'.'
      Else
        Txt:=Txt+Chr(GetMemData(Ptr(myMem+i),STRUCT_BYTE));
    End;
    AddText(Txt,false);
    myMem:=myMem+16;
  End;
  AddText('--------------------------------------------------------------------------------------',false);
  AddText('-> Die nchsten 1024 Bytes',false);
  AktNode^.ObjName:='XPTR';  AktNode^.Address:=Ptr(myMem);
  StatusText:='1024 Bytes ab Adresse $'+Dez2Hex(Long(AktPtr))+' bis $'+Dez2Hex(myMem-4);
END;


PROCEDURE GetStructure(AktPtr :Ptr;ObjName :String);

VAR     myStruct        :^Struct;
        myNode          :^Node;
        Wid             :Long;
        Merk            :^Merker;
    Tags            :Array[1..2] of TagItem;
        Txt             :String;
        AktLib          :^LibTyp;

  PROCEDURE WriteContents(AktStructTyp :p_StructTyp);

  VAR   myStrTyp        :^StructTyp;
        myStruct        :^Struct;

  BEGIN
    New(AktNode);
    AktNode^.Name:=Copy('               ',1,dum)+FormText(AktStructTyp^.Name,Wid+1,true);
    AktNode^.ObjName:=AktStructTyp^.Typ;
    AktNode^.Node.ln_Name:=AktNode^.Name;
    If AktStructTyp^.Node.ln_Type In [STRUCT_PTR,STRUCT_BPTR,STRUCT_PSTRUCT] Then Begin
      If (Long(StructAddress)-Long(AktPtr)) Mod 2=1 Then
        StructAddress:=Ptr(Long(StructAddress)+1);
      AktNode^.Address:=Ptr(GetMemData(StructAddress,STRUCT_LONG));
      If AktStructTyp^.Node.ln_Type=STRUCT_BPTR Then
        AktNode^.Address:=Ptr(Long(AktNode^.Address) shl 2);
    End Else
      AktNode^.Address:=Nil;
    AddTail(^Liste,^AktNode^);
    Case AktStructTyp^.Node.ln_Type Of
      STRUCT_PSTRUCT: Begin
                        Txt:='$'+Dez2Hex(GetMemData(StructAddress,STRUCT_LONG));
                        AktNode^.Name:=AktNode^.Name+Txt+' :^'+AktStructTyp^.Typ;
                      End;
      STRUCT_UWORD: AktNode^.Name:=AktNode^.Name+FormText(IntStr(GetMemData(StructAddress,STRUCT_UWORD)),9,false)+' :Word';
      STRUCT_FLGWORD: Begin
                        Txt:='$'+Copy(Dez2Hex(GetMemData(StructAddress,STRUCT_UWORD)),5,4);
                        AktNode^.Name:=AktNode^.Name+FormText(Txt,9,false)+' :Word';
                      End;
      STRUCT_WORD: AktNode^.Name:=AktNode^.Name+FormText(IntStr(GetMemData(StructAddress,STRUCT_WORD)),9,false)+' :Unsigned Word';
      STRUCT_UBYTE: AktNode^.Name:=AktNode^.Name+FormText(IntStr(GetMemData(StructAddress,STRUCT_UBYTE)),9,false)+' :Unsigned Byte';
      STRUCT_FLGBYTE: Begin
                        Txt:='$'+Copy(Dez2Hex(GetMemData(StructAddress,STRUCT_UBYTE)),7,2);
                        AktNode^.Name:=AktNode^.Name+FormText(Txt,9,false)+' :Unsigned Byte';
                      End;
      STRUCT_BYTE: AktNode^.Name:=AktNode^.Name+FormText(IntStr(GetMemData(StructAddress,STRUCT_BYTE)),9,false)+' :Byte';
      STRUCT_LONG: AktNode^.Name:=AktNode^.Name+FormText(IntStr(GetMemData(StructAddress,STRUCT_LONG)),9,false)+' :Long';
      STRUCT_FLGLONG: Begin
                        Txt:='$'+Dez2Hex(GetMemData(StructAddress,STRUCT_LONG));
                        AktNode^.Name:=AktNode^.Name+FormText(Txt,9,false)+' :Long';
                      End;
      STRUCT_STRING: Begin
                       Txt:=chr(13)+chr(10);
                       If Pos(Txt,Str(GetMemData(StructAddress,STRUCT_LONG)))>0 Then
                         Txt:=Copy(Str(GetMemData(StructAddress,STRUCT_LONG)),1,Pos(Txt,Str(GetMemData(StructAddress,STRUCT_LONG)))-1)
                       Else
                         Txt:=Str(GetMemData(StructAddress,STRUCT_LONG));
                       AktNode^.Name:=AktNode^.Name+'"'+Txt+'"';
                     End;
      STRUCT_PTR: Begin
                    Txt:='$'+Dez2Hex(GetMemData(StructAddress,STRUCT_LONG));
                    AktNode^.Name:=AktNode^.Name+FormText(Txt,9,false)+' :Ptr';
                  End;
      STRUCT_BPTR: Begin
                     Txt:='$'+Dez2Hex(GetMemData(StructAddress,STRUCT_LONG));
                     AktNode^.Name:=AktNode^.Name+FormText(Txt,9,false)+' :BCPL-Ptr';
                   End;
      STRUCT_STRUCT: Begin
                       AktNode^.Name:=AktNode^.Name+'---------- '+AktStructTyp^.Typ;
                       myStruct:=p_Struct(FindName(^Structs,AktStructTyp^.Typ));
                       myStrTyp:=p_StructTyp(myStruct^.Entrys.lh_Head);
                       dum:=dum+2;  Wid:=Wid-2;
                       While myStrTyp^.Node.ln_Succ<>Nil Do Begin
                         WriteContents(myStrTyp);
                         myStrTyp:=p_StructTyp(myStrTyp^.Node.ln_Succ);
                       End;
                       dum:=dum-2;  Wid:=Wid+2;
                     End;
    Else;
    End;
    Case AktStructTyp^.Node.ln_Type Of
      STRUCT_LONG,STRUCT_PSTRUCT,STRUCT_FLGLONG,STRUCT_PTR,STRUCT_STRING,STRUCT_BPTR: StructAddress:=Ptr(Long(StructAddress)+4);
      STRUCT_WORD,STRUCT_UWORD,STRUCT_FLGWORD: StructAddress:=Ptr(Long(StructAddress)+2);
      STRUCT_BYTE,STRUCT_UBYTE,STRUCT_FLGBYTE: StructAddress:=Ptr(Long(StructAddress)+1);
    Else;
    End;
  END;

BEGIN
  If Libraries.lh_Head=^Libraries.lh_Tail Then
    LoadStructs;
  myStruct:=p_Struct(FindName(^Structs,ObjName));
  myNode:=AktPtr;
  If (myStruct<>Nil) and ((myStruct^.Name='Node') or (myStruct^.Name='MinNode')) Then Begin
    If (myNode^.ln_Pred=Nil) or (myNode^.ln_Succ=Nil) Then
      myStruct:=Nil;
    If myStruct=Nil Then
      AktPtr:=StructAddress;
  End;
  If (myStruct<>Nil) and (myStruct^.Name='Node') Then Begin
    Case myNode^.ln_Type Of
      NT_MESSAGE: myStruct:=NodeTypen[1];
      NT_FREEMSG: myStruct:=NodeTypen[2];
      NT_REPLYMSG: myStruct:=NodeTypen[3];
      NT_RESOURCE: myStruct:=NodeTypen[4];
      NT_GRAPHICS: myStruct:=NodeTypen[5];
      NT_TASK: myStruct:=p_Struct(FindName(^Structs,'Task'));
      NT_FONT: myStruct:=p_Struct(FindName(^Structs,'TextFont'));
      NT_MSGPORT: myStruct:=p_Struct(FindName(^Structs,'MsgPort'));
      NT_DEVICE: myStruct:=p_Struct(FindName(^Structs,'Device'));
      NT_PROCESS: myStruct:=p_Struct(FindName(^Structs,'Process'));
      NT_MESSAGE: myStruct:=p_Struct(FindName(^Structs,'Message'));
      NT_SIGNALSEM: myStruct:=p_Struct(FindName(^Structs,'SignalSemaphore'));
      NT_LIBRARY: Begin
                    AktLib:=p_LibTyp(Libraries.lh_Head);
                    While (AktLib^.Node.ln_Succ<>Nil) and (AktLib^.Name<>myNode^.ln_Name) Do
                      AktLib:=p_LibTyp(AktLib^.Node.ln_Succ);
                    If AktLib^.Name=myNode^.ln_Name Then
                      myStruct:=p_Struct(FindName(^Structs,AktLib^.Struct));
                    If (myStruct=Nil) or (AktLib^.Name<>myNode^.ln_Name) Then
                      myStruct:=p_Struct(FindName(^Structs,'Library'));
                  End;
    Else;
    End;
    If myStruct=Nil Then
      myStruct:=p_Struct(FindName(^Structs,ObjName));
  End;
  If myStruct<>Nil Then Begin
    If (AktStruct<>Nil) Then Begin
      New(Merk);
      Merk^.Struct:=AktStruct;
      Merk^.Address:=StructAddress;
      Tags[1]:=TagItem(GTLV_Top, Long(^Merk^.Top));
      Tags[2].ti_Tag:=TAG_DONE;
      If (IntuitionBase^.LibNode.lib_Version>38) and (GT_GetGadgetAttrsA(LstGad,Win,Nil,^Tags)=0) Then;
      AddTail(^MerkListe,^Merk^);
    End;
    AktStruct:=myStruct;
    StructAddress:=AktPtr;
  End Else If (AktPtr=StructAddress) and ((ObjName='Node') or (ObjName='MinNode')) Then Begin
    DisplayBeep(PubScr);
    StatusText:='Anfang oder Ende der Liste erreicht bzw. die Liste ist leer.'
  End Else Begin
    ErrorRequest('Die Struktur "'+ObjName+'" ist|noch nicht definiert.',false);
    StatusText:='Struktur "'+ObjName+'" nicht gefunden.';
  End;
  AddText('$'+Dez2Hex(Long(StructAddress))+' '+AktStruct^.Name,false);
  AktNode^.Address:=StructAddress;  AktNode^.ObjName:=AktStruct^.Name;
  AddText('--------------------------------------------------------------------------------------',false);
  Wid:=GetLongestName(AktStruct);  dum:=0;  If Wid<30 Then Wid:=30;
  AktStructTyp:=p_StructTyp(AktStruct^.Entrys.lh_Head);
  While AktStructTyp^.Node.ln_Succ<>Nil Do Begin
    WriteContents(AktStructTyp);
    AktStructTyp:=p_StructTyp(AktStructTyp^.Node.ln_Succ);
  End;
  StructAddress:=AktPtr;
  If StatusText='' Then
    StatusText:='Die Struktur "'+AktStruct^.Name+'" ist '+IntStr(AktStruct^.Length)+' Bytes lang';
END;


PROCEDURE GetStructureBase;

VAR     Count   :Long;
        myNode  :^Node;
        ExBase  :^ExecBase;
        AktLib  :^LibTyp;

BEGIN
  ExBase:=SysBase;
  If Libraries.lh_Head=^Libraries.lh_Tail Then
    LoadStructs;
  StructAddress:=Nil;  AktStruct:=Nil;
  AddText('Vorhandene Library-Basis-Strukturen:',false);
  AddText('',false);
  AddText('  Adresse  Name                    Library',false);
  AddText('  ----------------------------------------------------------------',false);
  AktLib:=p_LibTyp(Libraries.lh_Head);
  While (AktLib^.Node.ln_Succ<>Nil) Do Begin
    myNode:=FindName(^ExBase^.LibList,AktLib^.Name);
    If myNode<>Nil Then Begin
      New(AktNode);  AktNode^.Address:=myNode;
      AktNode^.Name:='  '+Dez2Hex(Long(AktNode^.Address))+' '+FormText(AktLib^.Struct,23,true)+' '+AktLib^.Name;
      AktNode^.ObjName:='Node';
      AktNode^.Node.ln_Name:=AktNode^.Name;
      AddTail(^Liste,^AktNode^);
    End;
    AktLib:=p_LibTyp(AktLib^.Node.ln_Succ);
  End;
  AddText('',false);
  Count:=0;
  myNode:=Structs.lh_Head;
  While myNode^.ln_Succ<>Nil Do Begin
    Inc(Count);
    myNode:=myNode^.ln_Succ;
  End;
  FreeMerkListe;
  StatusText:=IntStr(Count)+' Strukturdefinition(en) gefunden.';
END;


PROCEDURE GetInfos;
                                         {Infos - nicht verndern}
BEGIN
  AddText('',false);
  AddText('XOpa in der Version '+_VERSION,true);
  AddText('',false);
  AddText('',false);
  AddText('programmiert von Axel Drfler',true);
  AddText('Vielen Dank fr die Untersttzung von Alexander Bartz',true);
  AddText('',false);
  AddText('',false);
  AddText('Kontaktadresse zum kontaktieren der Kontaktperson:',true);
  AddText('',false);
  AddText('Axel Drfler',true);
  AddText('Heerstrae 53',true);
  AddText('49492 Westerkappeln',true);
  AddText('',false);
  AddText('Dieses Programm kann bei Unwissenheit Systemabstrze herbeifhren.',true);
  AddText('Dies tritt dann auf, wenn Sie noch bentigte Daten entfernen, da das',true);
  AddText('Programm selber keine Mglichkeit besitzt, dies zu berprfen.',true);
  AddText('',false);
  AddText('Vor der ausgiebigen Nutzung des Programmes sollten',true);
  AddText('Sie alle wichtigen Daten abspeichern.',true);
  AddText('Fr weitere Informationen und Bedienungshinweise',true);
  AddText('lesen Sie bitte die Dokumentation.',true);
  AddText('',false);
  AddText('Fr vom Programm oder dessen Anwender verursachten Schaden',true);
  AddText('wird nicht gehaftet.',true);
  AddText('',false);
  AddText('',false);
  AddText('Falls Sie Verbesserungs- bzw. Erweiterungsvorschlge',true);
  AddText('haben, oder auch irgendwelche Programmfehler entdecken,',true);
  AddText('wrden ich mich ber eine Meldung von Ihnen freuen.',true);
  AddText('',false);
  AddText('',false);
  AddText('Das Programm wurde komplett in Kick-Pascal 2.12',true);
  AddText('der Maxon-Computer GmbH geschrieben.',true);
END;

{beim Doppelklick auf ein Listengadget werden diese Funktionen aufgerufen}

PROCEDURE GetMoreFont(myFont :p_TextFont);

VAR     WinReq  :^Window;
        MsgReq  :^IntuiMessage;
        GadLst  :^Gadget;
        NGad    :NewGadget;
        Gad,FGad:^Gadget;
        Tags    :Array[1..5] of TagItem;
        WinTags :Array[1..10] of TagItem;
        SInfo   :^StringInfo;
        Txt     :AppString;
        WTitle  :Str;
        ok      :Boolean;

BEGIN
  FGad:=CreateContext(^GadLst);
  If FGad=Nil Then
    ErrorRequest('Ciao Mdels!',true);
  Txt:='XOpa-Zeichensatzanzeige ('+myFont^.tf_Message.mn_Node.ln_Name+'/'+IntStr(myFont^.tf_YSize)+')';  WTitle:=Txt;
  WinTags[1]:=TagItem(WA_Width,       PubScr^.Width Div 3*2);
  WinTags[2]:=TagItem(WA_Height,      PubScr^.BarHeight+myFont^.tf_YSize+PubScr^.Font^.ta_YSize+22);
  WinTags[3]:=TagItem(WA_IDCMP,       IDCMP_GADGETUP or IDCMP_CLOSEWINDOW);
  WinTags[4]:=TagItem(WA_Flags,       WFLG_DEPTHGADGET or WFLG_DRAGBAR or WFLG_ACTIVATE or WFLG_CLOSEGADGET);
  WinTags[5]:=TagItem(WA_Title,       Long(WTitle));
  WinTags[6]:=TagItem(WA_Gadgets,     Long(FGad));
  WinTags[7]:=TagItem(WA_Left,        Win^.LeftEdge+Msg^.MouseX-WinTags[1].ti_Data shr 1);
  WinTags[8]:=TagItem(WA_Top,         Win^.TopEdge+Msg^.MouseY-PubScr^.BarHeight-myFont^.tf_YSize-14-(PubScr^.Font^.ta_YSize+4) shr 1);
  WinTags[9].ti_Tag:=TAG_DONE;
  NGad:=NewGadget(WinTags[1].ti_Data shr 1-TLn('Ok') shr 1-32,PubScr^.BarHeight+14+myFont^.tf_YSize,TLn('Ok')+64,PubScr^.Font^.ta_YSize+3,'Ok',PubScr^.Font,1,PLACETEXT_IN,VInfo,Nil);
  Gad:=CreateGadgetA(BUTTON_KIND,FGad,^NGad,Nil);
  WinReq:=OpenWindowTagList(Nil, ^WinTags);
  If WinReq=Nil Then
    ErrorRequest('Ciao Mdels!',true);
  Txt:='123 AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsTtUuVvWwXxYyZz';
  Tags[1]:=TagItem(GT_VisualInfo,  Long(VInfo));
  Tags[2]:=TagItem(GTBB_Recessed,  Long(true));
  Tags[3].ti_Tag:=TAG_DONE;
  DrawBevelBoxA(WinReq^.RPort,8,WinReq^.BorderTop+3,WinReq^.Width-16,myFont^.tf_YSize+7,^Tags);
  If SetFont(WinReq^.RPort, myFont)>0 Then;
  dum:=14;
  If TextLength(WinReq^.RPort, Txt, Length(Txt))>=WinReq^.Width-28 Then Begin
    While TextLength(WinReq^.RPort, Txt, Length(Txt))>=WinReq^.Width-28 Do
      Txt:=Copy(Txt,1,Length(Txt)-1);
  End Else
    dum:=WinReq^.Width shr 1-TextLength(WinReq^.RPort, Txt, Length(Txt)) shr 1;
  SetAPen(WinReq^.RPort, 1);
  Move(WinReq^.RPort, dum, WinReq^.BorderTop+7+myFont^.tf_BaseLine);
  If _Text(WinReq^.RPort, Txt, Length(Txt)) Then;
  MsgReq:=Wait_Port(WinReq^.UserPort);
  MsgReq:=GT_GetIMsg(WinReq^.UserPort);
  GT_ReplyIMsg(MsgReq);
  CloseWindow(WinReq);
  FreeGadgets(GadLst);
  AktNode:=Nil;
END;


PROCEDURE GetMoreScreen(Scr :p_Screen);

VAR     Mode    :Long;

BEGIN
  StatusText:='Informationen zu '+chr(34)+Scr^.Title+chr(34)+'.';
  AddText('Screen:   LeftEdge:    '+FormText(IntStr(Scr^.LeftEdge),5,false)+'       Width:       '+FormText(IntStr(Scr^.Width),5,false),false);
  AddText('          TopEdge:     '+FormText(IntStr(Scr^.TopEdge),5,false)+'       Height:      '+FormText(IntStr(Scr^.Height),5,false),false);
  AddText('          Depth:       '+FormText(IntStr(Scr^.RastPort.BitMap^.Depth),5,false),false);
  AddText('',false);
  AddText('          BarHeight:   '+FormText(IntStr(Scr^.BarHeight),5,false)+'       MenuVBorder: '+FormText(IntStr(Scr^.MenuVBorder),5,false),false);
  AddText('          BarVBorder:  '+FormText(IntStr(Scr^.BarVBorder),5,false)+'       MenuHBorder: '+FormText(IntStr(Scr^.MenuHBorder),5,false),false);
  AddText('          BarHBorder:  '+FormText(IntStr(Scr^.BarHBorder),5,false),false);
  AddText('',false);
  AddText('          WBorTop:     '+FormText(IntStr(Scr^.WBorTop),5,false)+'       DetailPen:   '+FormText(IntStr(Scr^.DetailPen),5,false),false);
  AddText('          WBorLeft:    '+FormText(IntStr(Scr^.WBorLeft),5,false)+'       BlockPen:    '+FormText(IntStr(Scr^.BlockPen),5,false),false);
  AddText('          WBorRight:   '+FormText(IntStr(Scr^.WBorRight),5,false)+'       DxOffset:   '+FormText(IntStr(Scr^.ViewPort.DxOffset),6,false),false);
  AddText('          WBorBottom:  '+FormText(IntStr(Scr^.WBorBottom),5,false)+'       DyOffset:   '+FormText(IntStr(Scr^.ViewPort.DyOffset),6,false),false);
  AddText('',false);
  AddText('          Layer:    '+Dez2Hex(Long(Scr^.RastPort.Layer))+'       BarLayer: '+Dez2Hex(Long(Scr^.BarLayer)),false);
  AddText('          TmpRas:   '+Dez2Hex(Long(Scr^.RastPort.TmpRas))+'       ExtData:  '+Dez2Hex(Long(Scr^.ExtData)),false);
  AddText('          RasInfo:  '+Dez2Hex(Long(Scr^.ViewPort.RasInfo))+'       UserData: '+Dez2Hex(Long(Scr^.UserData)),false);
  AddText('',false);
  AddText('          Title:          '+chr(34)+Scr^.Title+chr(34),false);
  AddText('          DefaultTitle:   '+chr(34)+Scr^.DefaultTitle+chr(34),false);
  AddText('          TextAttr:       '+chr(34)+Scr^.Font^.ta_Name+chr(34)+' ($'+Dez2Hex(Long(Scr^.Font))+')',false);
  AddText('',false);
  AddText('',false);
  New(AktNode);  AktNode^.Name:='ModeID:   ';  AktNode^.Address:=Ptr(0);
  Mode:=GetVPModeID(^Scr^.ViewPort);
  dum:=MONITOR_ID_MASK;
  If (Mode and dum)=$11000 Then
    AddFlagText('NTSC-Modus',10)
  Else If (Mode and dum)=$21000 Then
    AddFlagText('PAL-Modus',10)
  Else If (Mode and dum)=$31000 Then
    AddFlagText('MULTISCAN-Modus',10)
  Else If (Mode and dum)=$61000 Then
    AddFlagText('EURO72-Modus',10)
  Else If (Mode and dum)=$71000 Then
    AddFlagText('EURO36-Modus',10)
  Else If (Mode and dum)=$81000 Then
    AddFlagText('SUPER72-Modus',10)
  Else If (Mode and dum)=$91000 Then
    AddFlagText('DblNTSC-Modus',10)
  Else If (Mode and dum)=$a1000 Then
    AddFlagText('DblPAL-Modus',10)
  Else If (Mode and dum)=0 Then
    AddFlagText('DEFAULT-Modus',10)
  Else
    AddFlagText('unbekannter Modus ($'+Dez2Hex(Mode)+')',10);
  If ((Mode and dum)=$11000) or ((Mode and dum)=$21000) or ((Mode and dum)=$71000) or ((Mode and dum)=$81000)  or ((Mode and dum)=$0) Then Begin
    If ((Mode and Not dum) and $8020)=$8020 Then
      AddFlagText('SuperHiRes',10)
    Else If ((Mode and Not dum) and $8000)=$8000 Then
      AddFlagText('HiRes',10)
    Else If ((Mode and Not dum) and $f020)=0 Then
      AddFlagText('LoRes',10);
    If ((Mode and Not dum) and $4)=$4 Then
      AddFlagText('Interlace',10);
  End Else If ((Mode and dum)=$31000) or ((Mode and dum)=$61000) Then Begin
    If ((Mode and Not dum) and $8020)=$8020 Then
      AddFlagText('Productivity',10)
    Else If ((Mode and Not dum) and $8000)=$8000 Then
      AddFlagText('LoRes',10)
    Else If ((Mode and Not dum) and $f020)=0 Then
      AddFlagText('ExtraLoRes',10);
    If ((Mode and Not dum) and $5)=$5 Then
      AddFlagText('Interlace',10);
  End Else If ((Mode and dum)=$91000) or ((Mode and dum)=$a1000) Then Begin
    If ((Mode and Not dum) and $8000)=$8000 Then
      AddFlagText('HiRes',10)
    Else If ((Mode and Not dum) and $f020)=0 Then
      AddFlagText('LoRes',10);
    If ((Mode and Not dum) and $5)=$5 Then
      AddFlagText('Interlace',10)
    Else If ((Mode and Not dum) and $f)=$0 Then
      AddFlagText('ScanDouble',10);
  End;

  If (((Mode and Not dum) and $800)=$800) and (Scr^.RastPort.BitMap^.Depth>6) Then
    AddFlagText('HAM8',10);
  If (((Mode and Not dum) and $800)=$800) and (Scr^.RastPort.BitMap^.Depth<7) Then
    AddFlagText('HAM6',10);
  If ((Mode and Not dum) and $80)=$80 Then
    AddFlagText('EHB',10);
  If ((Mode and Not dum) and $400)=$400 Then
    AddFlagText('DualPlayField',10);
  AktNode^.Name:=Copy(AktNode^.Name,1,Length(AktNode^.Name)-3);
  AktNode^.Node.ln_Name:=AktNode^.Name;  AddTail(^Liste, ^AktNode^.Node);
  AddText('',false);
  New(AktNode);  AktNode^.Name:='Flags:    ';  AktNode^.Address:=Ptr(0);
  If (Scr^.Flags and $10)=$10 Then
    AddFlagText('SHOWTITLE',10);
  If (Scr^.Flags and $20)=$20 Then
    AddFlagText('BEEPING',10);
  If (Scr^.Flags and $40)=$40 Then
    AddFlagText('CUSTOMBITMAP',10);
  If (Scr^.Flags and $80)=$80 Then
    AddFlagText('SCREENBEHIND',10);
  If (Scr^.Flags and $100)=$100 Then
    AddFlagText('SCREENQUIET',10);
  If (Scr^.Flags and $200)=$200 Then
    AddFlagText('SCREENHIRES',10);
  If (Scr^.Flags and $1000)=$1000 Then
    AddFlagText('NS_EXTENDED',10);
  If (Scr^.Flags and $4000)=$4000 Then
    AddFlagText('AUTOSCROLL',10);
  AktNode^.Name:=Copy(AktNode^.Name,1,Length(AktNode^.Name)-3);
  AktNode^.Node.ln_Name:=AktNode^.Name;  AddTail(^Liste, ^AktNode^.Node);
  AddText('',false);
END;


PROCEDURE GetMoreWindow(myWin :p_Window);

BEGIN
  StatusText:='Informationen zu '+chr(34)+myWin^.Title+chr(34)+' auf dem '+chr(34)+myWin^.WScreen^.Title+chr(34)+'-Bildschirm.';
  AddText('Window:   LeftEdge:      '+FormText(IntStr(myWin^.LeftEdge),5,false)+'       Width:        '+FormText(IntStr(myWin^.Width),5,false),false);
  AddText('          TopEdge:       '+FormText(IntStr(myWin^.TopEdge),5,false)+'       Height:       '+FormText(IntStr(myWin^.Height),5,false),false);
  AddText('',false);
  AddText('          MinWidth:     '+FormText(IntStr(myWin^.MinWidth),6,false)+'       BorderTop:     '+FormText(IntStr(myWin^.BorderTop),4,false),false);
  AddText('          MinHeight:    '+FormText(IntStr(myWin^.MinHeight),6,false)+'       BorderBottom:  '+FormText(IntStr(myWin^.BorderBottom),4,false),false);
  AddText('          MaxWidth:     '+FormText(IntStr(myWin^.MaxWidth),6,false)+'       BorderLeft:    '+FormText(IntStr(myWin^.BorderLeft),4,false),false);
  AddText('          MaxHeight:    '+FormText(IntStr(myWin^.MaxHeight),6,false)+'       BorderRight:   '+FormText(IntStr(myWin^.BorderRight),4,false),false);
  AddText('',false);
  AddText('          UserPort:   '+Dez2Hex(Long(myWin^.UserPort))+'       DetailPen:     '+FormText(IntStr(myWin^.DetailPen),4,false),false);
  AddText('          WindowPort: '+Dez2Hex(Long(myWin^.UserPort))+'       BlockPen:      '+FormText(IntStr(myWin^.BlockPen),4,false),false);
  AddText('',false);
  AddText('          RastPort:   '+Dez2Hex(Long(myWin^.RPort))+'       MenuStrip:  '+Dez2Hex(Long(myWin^.MenuStrip)),false);
  AddText('          BordeRPort: '+Dez2Hex(Long(myWin^.BorderRPort))+'       CheckMark:  '+Dez2Hex(Long(myWin^.CheckMark)),false);
  AddText('          WinLayer:   '+Dez2Hex(Long(myWin^.WLayer))+'       Pointer:    '+Dez2Hex(Long(myWin^.Pointer)),false);
  AddText('',false);
  AddText('          FirstReq:   '+Dez2Hex(Long(myWin^.FirstRequest))+'       ExtData:    '+Dez2Hex(Long(myWin^.ExtData)),false);
  AddText('          DMRequest:  '+Dez2Hex(Long(myWin^.DMRequest))+'       UserData:   '+Dez2Hex(Long(myWin^.UserData)),false);
  AddText('          ReqCount:      '+FormText(IntStr(myWin^.ReqCount),5,false),false);
  AddText('',false);
  If myWin^.NextWindow<>Nil Then
    AddText('          NextWindow: '+chr(34)+myWin^.NextWindow^.Title+chr(34)+' ($'+Dez2Hex(Long(myWin^.NextWindow))+')',false);
  If myWin^.Parent<>Nil Then
    AddText('          Parent:     '+chr(34)+myWin^.Parent^.Title+chr(34)+' ($'+Dez2Hex(Long(myWin^.Parent))+')',false);
  If myWin^.Descendant<>Nil Then
    AddText('          Descendant: '+chr(34)+myWin^.Descendant^.Title+chr(34)+' ($'+Dez2Hex(Long(myWin^.Descendant))+')',false);
  If Ptr(myWin^.ScreenTitle)<>Nil Then
    AddText('          ScrTitle:   '+chr(34)+myWin^.ScreenTitle+chr(34),false);
  AddText('          IFont:      '+chr(34)+myWin^.IFont^.tf_Message.mn_Node.ln_Name+chr(34)+' ($'+Dez2Hex(Long(myWin^.IFont))+')',false);
  AddText('',false);
  AddText('',false);
  New(AktNode);  AktNode^.Name:='Flags:    ';  AktNode^.Address:=Ptr(0);
  If (myWin^.Flags and $1)=$1 Then
    AddFlagText('WFLG_SIZEGADGET',10);
  If (myWin^.Flags and $2)=$2 Then
    AddFlagText('WFLG_DRAGBAR',10);
  If (myWin^.Flags and $4)=$4 Then
    AddFlagText('WFLG_DEPTHGADGET',10);
  If (myWin^.Flags and $8)=$8 Then
    AddFlagText('WFLG_CLOSEGADGET',10);
  If (myWin^.Flags and $10)=$10 Then
    AddFlagText('WFLG_SIZEBRIGHT',10);
  If (myWin^.Flags and $20)=$20 Then
    AddFlagText('WFLG_SIZEBBOTTOM',10);
  If (myWin^.Flags and $c0)=$c0 Then
    AddFlagText('WFLG_OTHER_REFRESH',10)
  Else If (myWin^.Flags and $c0)=$0 Then
    AddFlagText('WFLG_SMARTREFRESH',10)
  Else If (myWin^.Flags and $c0)=$40 Then
    AddFlagText('WFLG_SIMPLEREFRESH',10)
  Else If (myWin^.Flags and $c0)=$80 Then
    AddFlagText('WFLG_SUPER_BITMAP',10);
  If (myWin^.Flags and $100)=$100 Then
    AddFlagText('WFLG_BACKDROP',10);
  If (myWin^.Flags and $200)=$200 Then
    AddFlagText('WFLG_REPORTMOUSE',10);
  If (myWin^.Flags and $400)=$400 Then
    AddFlagText('WFLG_GIMMEZEROZERO',10);
  If (myWin^.Flags and $800)=$800 Then
    AddFlagText('WFLG_BORDERLESS',10);
  If (myWin^.Flags and $1000)=$1000 Then
    AddFlagText('WFLG_ACTIVATE',10);
  If (myWin^.Flags and $2000)=$2000 Then
    AddFlagText('WFLG_WINDOWACTIVE',10);
  If (myWin^.Flags and $4000)=$4000 Then
    AddFlagText('WFLG_INREQUEST',10);
  If (myWin^.Flags and $8000)=$8000 Then
    AddFlagText('WFLG_MENUSTATE',10);
  If (myWin^.Flags and $10000)=$10000 Then
    AddFlagText('WFLG_RMBTRAP',10);
  If (myWin^.Flags and $20000)=$20000 Then
    AddFlagText('WFLG_NOCAREREFRESH',10);
  If (myWin^.Flags and $40000)=$40000 Then
    AddFlagText('WFLG_NW_EXTENDED',10);
  If (myWin^.Flags and $1000000)=$1000000 Then
    AddFlagText('WFLG_WINDOWREFRESH',10);
  If (myWin^.Flags and $2000000)=$2000000 Then
    AddFlagText('WFLG_WBENCHWINDOW',10);
  If (myWin^.Flags and $4000000)=$4000000 Then
    AddFlagText('WFLG_WINDOWTICKED',10);
  If (myWin^.Flags and $8000000)=$8000000 Then
    AddFlagText('WFLG_VISITOR',10);
  If (myWin^.Flags and $10000000)=$10000000 Then
    AddFlagText('WFLG_ZOOMED',10);
  If (myWin^.Flags and $20000000)=$20000000 Then
    AddFlagText('WFLG_HASZOOM',10);
  AktNode^.Name:=Copy(AktNode^.Name,1,Length(AktNode^.Name)-3);
  AktNode^.Node.ln_Name:=AktNode^.Name;  AddTail(^Liste, ^AktNode^.Node);
  AddText('',false);
  New(AktNode);  AktNode^.Name:='IDCMP:    ';  AktNode^.Address:=Ptr(0);
  If (myWin^.IDCMPFlags and $1)=$1 Then
    AddFlagText('IDCMP_SIZEVERIFY',10);
  If (myWin^.IDCMPFlags and $2)=$2 Then
    AddFlagText('IDCMP_NEWSIZE',10);
  If (myWin^.IDCMPFlags and $4)=$4 Then
    AddFlagText('IDCMP_REFRESHWINDOW',10);
  If (myWin^.IDCMPFlags and $8)=$8 Then
    AddFlagText('IDCMP_MOUSEBUTTONS',10);
  If (myWin^.IDCMPFlags and $10)=$10 Then
    AddFlagText('IDCMP_MOUSEMOVE',10);
  If (myWin^.IDCMPFlags and $20)=$20 Then
    AddFlagText('IDCMP_GADGETDOWN',10);
  If (myWin^.IDCMPFlags and $40)=$40 Then
    AddFlagText('IDCMP_GADGETUP',10);
  If (myWin^.IDCMPFlags and $80)=$80 Then
    AddFlagText('IDCMP_REQSET',10);
  If (myWin^.IDCMPFlags and $100)=$100 Then
    AddFlagText('IDCMP_MENUPICK',10);
  If (myWin^.IDCMPFlags and $200)=$200 Then
    AddFlagText('IDCMP_CLOSEWINDOW',10);
  If (myWin^.IDCMPFlags and $400)=$400 Then
    AddFlagText('IDCMP_RAWKEY',10);
  If (myWin^.IDCMPFlags and $800)=$800 Then
    AddFlagText('IDCMP_REQVERIFY',10);
  If (myWin^.IDCMPFlags and $1000)=$1000 Then
    AddFlagText('IDCMP_REQCLEAR',10);
  If (myWin^.IDCMPFlags and $2000)=$2000 Then
    AddFlagText('IDCMP_MENUVERIFY',10);
  If (myWin^.IDCMPFlags and $4000)=$4000 Then
    AddFlagText('IDCMP_NEWPREFS',10);
  If (myWin^.IDCMPFlags and $8000)=$8000 Then
    AddFlagText('IDCMP_DISKINSERTED',10);
  If (myWin^.IDCMPFlags and $10000)=$10000 Then
    AddFlagText('IDCMP_DISKREMOVED',10);
  If (myWin^.IDCMPFlags and $20000)=$20000 Then
    AddFlagText('IDCMP_WBENCHMESSAGE',10);
  If (myWin^.IDCMPFlags and $40000)=$40000 Then
    AddFlagText('IDCMP_ACTIVEWINDOW',10);
  If (myWin^.IDCMPFlags and $80000)=$80000 Then
    AddFlagText('IDCMP_INACTIVEWINDOW',10);
  If (myWin^.IDCMPFlags and $100000)=$100000 Then
    AddFlagText('IDCMP_DELTAMOVE',10);
  If (myWin^.IDCMPFlags and $200000)=$200000 Then
    AddFlagText('IDCMP_VANILLAKEY',10);
  If (myWin^.IDCMPFlags and $400000)=$400000 Then
    AddFlagText('IDCMP_INTUITICKS',10);
  If (myWin^.IDCMPFlags and $800000)=$800000 Then
    AddFlagText('IDCMP_IDCMPUPDATE',10);
  If (myWin^.IDCMPFlags and $1000000)=$1000000 Then
    AddFlagText('IDCMP_MENUHELP',10);
  If (myWin^.IDCMPFlags and $2000000)=$2000000 Then
    AddFlagText('IDCMP_CHANGEWINDOW',10);
  If (myWin^.IDCMPFlags and $80000000)=$80000000 Then
    AddFlagText('IDCMP_LONELYMESSAGE',10);
  AktNode^.Name:=Copy(AktNode^.Name,1,Length(AktNode^.Name)-3);
  AktNode^.Node.ln_Name:=AktNode^.Name;  AddTail(^Liste, ^AktNode^.Node);
  AddText('',false);
END;


PROCEDURE GetMoreTask(myTask :p_Task);

VAR     myProc  :^Process;
        myCLI   :^CommandLineInterface;
        myWin   :^Window;
        Seg     :^Segment;
        Txt     :AppString;
        OldLock :BPTR;

BEGIN
  myProc:=Nil;
  If myTask^.tc_Node.ln_Type=13 Then
    myProc:=^myTask^;
  StatusText:='Informationen zu '+chr(34)+TaskNam(myTask)+chr(34)+' ($'+Dez2Hex(Long(^myTask^))+').';
  AddText('Task:    IDNestCnt:   '+FormText(IntStr(myTask^.tc_IDNestCnt),8,false)+'       TDNestCnt:    '+FormText(IntStr(myTask^.tc_TDNestCnt),8,false),false);
  AddText('',false);
  AddText('         SigAlloc:    '+Dez2Hex(myTask^.tc_SigAlloc)+'       SigWait:      '+Dez2Hex(myTask^.tc_SigWait),false);
  AddText('         SigReceived: '+Dez2Hex(myTask^.tc_SigRecvd)+'       SigExcept:    '+Dez2Hex(myTask^.tc_SigExcept),false);
  AddText('',false);
  AddText('         TrapAble:        '+Copy(Dez2Hex(myTask^.tc_TrapAble),5,4)+'       TrapData:     '+Dez2Hex(Long(myTask^.tc_TrapData)),false);
  AddText('         TrapAlloc:       '+Copy(Dez2Hex(myTask^.tc_TrapAlloc),5,4)+'       TrapCode:     '+Dez2Hex(Long(myTask^.tc_TrapCode)),false);
  AddText('',false);
  AddText('         ExceptData:  '+Dez2Hex(Long(myTask^.tc_ExceptData))+'       ExceptCode:   '+Dez2Hex(Long(myTask^.tc_ExceptCode)),false);
  AddText('',false);
  AddText('         SPReg:       '+Dez2Hex(Long(myTask^.tc_SPReg))+'       Switch:       '+Dez2Hex(Long(myTask^.tc_Switch)),false);
  AddText('         SPLower:     '+Dez2Hex(Long(myTask^.tc_SPLower))+'       Launch:       '+Dez2Hex(Long(myTask^.tc_Launch)),false);
  AddText('         SPUpper:     '+Dez2Hex(Long(myTask^.tc_SPUpper))+'       UserData:     '+Dez2Hex(Long(myTask^.tc_UserData)),false);
  AddText('',false);
  If myProc=Nil Then
    Exit;
  AddText('',false);
  myWin:=myProc^.pr_WindowPtr;
  If myWin=Nil Then
    AddText('Process: WindowPtr:   keiner',false)
  Else
    AddText('Process: WindowPtr:   '+Dez2Hex(Long(myProc^.pr_WindowPtr))+'       Fenstertitel: '+chr(34)+myWin^.Title+chr(34),false);
  AddText('',false);
  OldLock:=CurrentDir(myProc^.pr_CurrentDir);
  Txt:='';
  FullName(myProc^.pr_CurrentDir, Txt);
  OldLock:=CurrentDir(OldLock);
  AddText('         CurrentDir:  '+Dez2Hex(myProc^.pr_CurrentDir shl 2)+'       Akt. Pfad:    '+chr(34)+Txt+chr(34),false);
  OldLock:=CurrentDir(myProc^.pr_HomeDir);
  Txt:='';
  FullName(myProc^.pr_HomeDir, Txt);
  OldLock:=CurrentDir(OldLock);
  AddText('         HomeDir:     '+Dez2Hex(myProc^.pr_HomeDir shl 2)+'       Programmpfad: '+chr(34)+Txt+chr(34),false);
  AddText('',false);
  AddText('         CIS:         '+Dez2Hex(myProc^.pr_CIS shl 2)+'       ConsoleTask:  '+Dez2Hex(Long(myProc^.pr_ConsoleTask)),false);
  AddText('         COS:         '+Dez2Hex(myProc^.pr_COS shl 2)+'       FileSysTask:  '+Dez2Hex(Long(myProc^.pr_FileSystemTask)),false);
  AddText('         CES:         '+Dez2Hex(myProc^.pr_CES shl 2)+'       ComLineInt:   '+Dez2Hex(Long(myProc^.pr_CLI)),false);
  AddText('         SegList:     '+Dez2Hex(myProc^.pr_SegList shl 2),false);
  AddText('',false);
  If myProc^.pr_CLI=0 Then
    Exit;
  AddText('',false);
  myCLI:=Ptr(myProc^.pr_CLI shl 2);
  AddText('CLI:     CurrentInput:  '+Dez2Hex(myCLI^.cli_CurrentInput shl 2)+'       CurrentOutput:  '+Dez2Hex(myCLI^.cli_CurrentOutput shl 2),false);
  AddText('         StandardInput: '+Dez2Hex(myCLI^.cli_StandardInput shl 2)+'       StandardOutput: '+Dez2Hex(myCLI^.cli_StandardOutput shl 2),false);
  AddText('',false);
  AddText('         CommandName:   '+chr(34)+BCPLString(Ptr(myCLI^.cli_CommandName shl 2))+chr(34),false);
  AddText('         SetName:       '+chr(34)+BCPLString(Ptr(myCLI^.cli_SetName shl 2))+chr(34),false);
  AddText('',false);
END;


PROCEDURE DrawMask;

VAR     Tags    :Array[1..5] of TagItem;
        IText   :IntuiText;
        i,Width :Integer;
        Txt,Txt2 :String;

BEGIN
  SetAPen(Win^.RPort, 0);
  RectFill(Win^.RPort, 8,PubScr^.BarHeight+3, Win^.Width-8,PubScr^.BarHeight+5+Tatter.ta_YSize);
  Tags[1]:=TagItem(GT_VisualInfo,  Long(VInfo));
  Tags[2].ti_Tag:=TAG_DONE;
  dum:=8;
  Txt:=TitleTexts^[DispMode];
  While Txt<>'' Do Begin
    If Pos('|',Txt)>0 Then Begin
      Txt2:=Copy(Txt,1,Pos('|',Txt)-1);
      Width:=TatXSize*(Length(Txt2)+1)
    End Else Begin
      Txt2:=Txt;
      Width:=Win^.Width-dum-8;
    End;
    IText:=IntuiText(1,0,0,0,0,^Tatter,Txt2,Nil);
    PrintIText(Win^.RPort,^IText, dum+4,PubScr^.BarHeight+5);
    DrawBevelBoxA(Win^.RPort,  dum,PubScr^.BarHeight+3, Width,Tatter.ta_YSize+3,^Tags);
    If Pos('|',Txt)>0 Then
      Txt:=Copy(Txt,Length(Txt2)+2,Length(Txt))
    Else
      Txt:='';
    dum:=dum+Width;
  End;
  Tags[1]:=TagItem(GT_VisualInfo,  Long(VInfo));
  Tags[2]:=TagItem(GTBB_Recessed,  Long(true));
  Tags[3].ti_Tag:=TAG_DONE;
  DrawBevelBoxA(Win^.RPort,8,LstGad^.TopEdge+LstGad^.Height,Win^.Width-16,Tatter.ta_YSize+3,^Tags);
  Tags[1]:=TagItem(GA_Disabled, Long(true));
  Tags[2].ti_Tag:=TAG_DONE;
  For dum:=1 to 8 Do Begin
    If (DispMode=22) and (dum=7) Then
      Tags[1].ti_Data:=Long(false)
    Else If (DispMode=21) and (dum=7) Then
      Tags[1].ti_Data:=Long(false)
    Else If (DispMode=34) and (dum=8) Then
      Tags[1].ti_Data:=Long(false)
    Else If DispMode>20 Then
      Tags[1].ti_Data:=Long(true)
    Else If (DispMode=12) and (MerkListe.lh_Head=^MerkListe.lh_Tail) Then
      Tags[1].ti_Data:=Long(true)
    Else
      Tags[1].ti_Data:=Long((ActiveGads[DispMode] and (1 shl (8-dum)))=0);
    GT_SetGadgetAttrsA(Gads[dum], Win, Nil, ^Tags);
  End;
  Tags[1]:=TagItem(GTLV_Labels, Long(^Liste));
  Tags[2]:=TagItem(GTLV_Top,    0);
  Tags[3].ti_Tag:=TAG_DONE;
  GT_SetGadgetAttrsA(LstGad, Win, Nil, ^Tags);
  DrawStatus;
END;


PROCEDURE ShowGuide(NodeName :String;NodeLine :Long);

VAR     nag     :^NewAmigaGuide;
        handle  :Ptr;

  PROCEDURE SetNode(Txt1 :String;Line :Long);

  BEGIN
    NodeName:=Txt1;
    nag^.nag_Line:=Line;
  END;

BEGIN
  If AmigaGuideBase=Nil Then
    Exit;
  New(nag);
  If NodeName='' Then Begin
    Case DispMode Of
      1,21: SetNode('Anzeige',8);
      2,22: SetNode('Anzeige',32);
      3: SetNode('Anzeige',56);
      4: SetNode('Anzeige',77);
      5: SetNode('Anzeige',100);
      6: SetNode('Anzeige',125);
      7: SetNode('Anzeige',149);
      8: SetNode('Anzeige',192);
      9: SetNode('Anzeige',215);
      10: SetNode('Anzeige',228);
      11: SetNode('Anzeige',243);
      12: SetNode('Struktur',0);
      13: SetNode('ber',0);
      14,34: SetNode('Funks',86);
    Else;
    End;
  End Else
    nag^.nag_Line:=NodeLine;
  nag^.nag_Name:='PROGDIR:XOpa.guide';
  nag^.nag_Node:=NodeName;
  SetWaitPointer(true);
  handle:=OpenAmigaGuideA(nag,Nil);
  SetWaitPointer(false);
  If (handle<>Nil) and (IOErr=0) Then
    CloseAmigaGuide(handle)
  Else Begin
    Case IOErr Of
      100: NodeName:='Nicht gengend Speicher!';
      101: NodeName:='Konnte "XOpa.guide" nicht ffnen!';
      102: NodeName:='Kann Node nicht finden!';
      103: NodeName:='Kann Node nicht ffnen!';
      104: NodeName:='Kann Fenster nicht ffnen!';
      105: NodeName:='Unbekannter Befehl!';
      107: NodeName:='Port geschlossen!';
      108: NodeName:='Kann Port nicht ffnen!';
      113: NodeName:='Schlsselwort nicht gefunden!';
    Else
      NodeName:='Unbekannter Guide-Fehler!'
    End;
    ErrorRequest(NodeName+'|Fehlernummer: '+IntStr(IOErr),false);
  End;
  Dispose(nag);
END;


PROCEDURE GetMoreInfos;

VAR     myPtr   :Ptr;
        Txt     :String;
                                                {ruft die richtige `More`-Funktion auf}
BEGIN
  If Not (DispMode In [1..6,11,12,14]) Then
    Exit;
  If DispMode=1 Then
    WinTask:=AktNode^.Address;
  If DispMode=2 Then
    ScrPtr:=AktNode^.Address;
  myPtr:=AktNode^.Address;
  Txt:=AktNode^.ObjName;
  If (DispMode>=3) and (DispMode<=6) Then Begin
    DispMode:=12;  Txt:='Node';  StructAddress:=myPtr;
    AktStruct:=p_Struct(FindName(^Structs,Txt));
  End;
  If (myPtr=Nil) and (DispMode=12) Then
    Exit;
  SetWaitPointer(true);
  FreeNodeList;
  StatusText:='';
  Case DispMode Of
     1: GetMoreTask(myPtr);
     2: GetMoreScreen(myPtr);
    11: GetMoreFont(myPtr);
    12: If Txt='XPTR' Then
          GetMemView(myPtr)
        Else
          GetStructure(myPtr,Txt);
    14: GetMoreWindow(myPtr);
  Else;
  End;
  If (DispMode<>11) Then Begin
    If (DispMode<>12) Then
      DispMode:=DispMode+20;
    DrawMask;
  End Else
    GetFontList;
  AktNode:=Nil;
  SetWaitPointer(false);
END;


PROCEDURE GetList;

VAR     Tags    :Array[1..3] of TagItem;
                                                {ruft eine der Listenfunktionen auf}
BEGIN
  SetWaitPointer(true);
  Tags[1]:=TagItem(GTLV_Labels, Long(Not 0));
  Tags[2].ti_Tag:=TAG_DONE;
  GT_SetGadgetAttrsA(LstGad, Win, Nil, ^Tags);
  FreeNodeList;
  StatusText:='';
  Case DispMode Of
     1: GetTaskList;
     2: GetScreenList;
     3: GetPortList;
     4..6: GetLibsList(DispMode);
     7: GetSystemInfo;
     8: GetIntrList;
     9: GetAssignList;
    10: GetResidents;
    11: GetFontList;
    12: GetStructureBase;
    13: GetInfos;
    14: GetWindowList;
  Else;
  End;
  If DispMode=14 Then
    DrawMask
  Else
    DrawStatus;
  AktNode:=Nil;
  Tags[1]:=TagItem(GTLV_Labels, Long(^Liste));
  Tags[2].ti_Tag:=TAG_DONE;
  GT_SetGadgetAttrsA(LstGad, Win, Nil, ^Tags);
  SetWaitPointer(false);
END;


FUNCTION MakeGadgets(Width,Height :Integer) : Long;

VAR     NGad    :Array[1..27] of NewGadget;
        Tags    :Array[1..5] of TagItem;
        FGad,Gad:^Gadget;
                                                {erstellt die GadTools-Gadgets}
BEGIN
  FGad:=Nil;
  FGad:=CreateContext(^GadList);
  If FGad=Nil Then
    ErrorRequest('Ciao Mdels!',true);
  dum:=(Width-16) Div 6;
  NGad[ 1]:=NewGadget(8,PubScr^.BarHeight+6+Tatter.ta_YSize,Width-16,Height-PubScr^.BarHeight-36-2*Tatter.ta_YSize-3*PubScr^.Font^.ta_YSize,Nil,^Tatter,1,0,VInfo,Nil);
  NGad[ 2]:=NewGadget(8,PubScr^.BarHeight+9+2*Tatter.ta_YSize+NGad[1].ng_Height+8+PubScr^.Font^.ta_YSize,dum,PubScr^.Font^.ta_YSize+3,'Tasks',PubScr^.Font,2,0,VInfo,Nil);
  NGad[ 3]:=NewGadget(8+dum,PubScr^.BarHeight+9+2*Tatter.ta_YSize+NGad[1].ng_Height+8+PubScr^.Font^.ta_YSize,dum,PubScr^.Font^.ta_YSize+3,'Screens',PubScr^.Font,3,0,VInfo,Nil);
  NGad[ 4]:=NewGadget(8+dum*2,PubScr^.BarHeight+9+2*Tatter.ta_YSize+NGad[1].ng_Height+8+PubScr^.Font^.ta_YSize,dum,PubScr^.Font^.ta_YSize+3,'Ports',PubScr^.Font,4,0,VInfo,Nil);
  NGad[ 5]:=NewGadget(8+dum*3,PubScr^.BarHeight+9+2*Tatter.ta_YSize+NGad[1].ng_Height+8+PubScr^.Font^.ta_YSize,dum,PubScr^.Font^.ta_YSize+3,'Libraries',PubScr^.Font,5,0,VInfo,Nil);
  NGad[ 6]:=NewGadget(8+dum*4,PubScr^.BarHeight+9+2*Tatter.ta_YSize+NGad[1].ng_Height+8+PubScr^.Font^.ta_YSize,dum,PubScr^.Font^.ta_YSize+3,'Resources',PubScr^.Font,6,0,VInfo,Nil);
  NGad[ 7]:=NewGadget(8+dum*5,PubScr^.BarHeight+9+2*Tatter.ta_YSize+NGad[1].ng_Height+8+PubScr^.Font^.ta_YSize,dum,PubScr^.Font^.ta_YSize+3,'Devices',PubScr^.Font,7,0,VInfo,Nil);
  NGad[ 8]:=NewGadget(8,PubScr^.BarHeight+12+2*Tatter.ta_YSize+NGad[1].ng_Height+8+2*PubScr^.Font^.ta_YSize,dum,PubScr^.Font^.ta_YSize+3,'System',PubScr^.Font,8,0,VInfo,Nil);
  NGad[ 9]:=NewGadget(8+dum,PubScr^.BarHeight+12+2*Tatter.ta_YSize+NGad[1].ng_Height+8+2*PubScr^.Font^.ta_YSize,dum,PubScr^.Font^.ta_YSize+3,'Interrupts',PubScr^.Font,9,0,VInfo,Nil);
  NGad[10]:=NewGadget(8+dum*2,PubScr^.BarHeight+12+2*Tatter.ta_YSize+NGad[1].ng_Height+8+2*PubScr^.Font^.ta_YSize,dum,PubScr^.Font^.ta_YSize+3,'Assigns',PubScr^.Font,10,0,VInfo,Nil);
  NGad[11]:=NewGadget(8+dum*3,PubScr^.BarHeight+12+2*Tatter.ta_YSize+NGad[1].ng_Height+8+2*PubScr^.Font^.ta_YSize,dum,PubScr^.Font^.ta_YSize+3,'Residents',PubScr^.Font,11,0,VInfo,Nil);
  NGad[12]:=NewGadget(8+dum*4,PubScr^.BarHeight+12+2*Tatter.ta_YSize+NGad[1].ng_Height+8+2*PubScr^.Font^.ta_YSize,dum,PubScr^.Font^.ta_YSize+3,'Fonts',PubScr^.Font,12,0,VInfo,Nil);
  NGad[13]:=NewGadget(8+dum*5,PubScr^.BarHeight+12+2*Tatter.ta_YSize+NGad[1].ng_Height+8+2*PubScr^.Font^.ta_YSize,dum,PubScr^.Font^.ta_YSize+3,'Struktur',PubScr^.Font,13,0,VInfo,Nil);
  dum:=(Width-16) Div 8;
  NGad[14]:=NewGadget(8,PubScr^.BarHeight+4+2*Tatter.ta_YSize+NGad[1].ng_Height+8,dum,PubScr^.Font^.ta_YSize+2,'Add',PubScr^.Font,14,0,VInfo,Nil);
  NGad[15]:=NewGadget(8+dum,PubScr^.BarHeight+4+2*Tatter.ta_YSize+NGad[1].ng_Height+8,dum,PubScr^.Font^.ta_YSize+2,'Remove',PubScr^.Font,15,0,VInfo,Nil);
  NGad[16]:=NewGadget(8+dum*2,PubScr^.BarHeight+4+2*Tatter.ta_YSize+NGad[1].ng_Height+8,dum,PubScr^.Font^.ta_YSize+2,'Signal',PubScr^.Font,16,0,VInfo,Nil);
  NGad[17]:=NewGadget(8+dum*3,PubScr^.BarHeight+4+2*Tatter.ta_YSize+NGad[1].ng_Height+8,dum,PubScr^.Font^.ta_YSize+2,'Priority',PubScr^.Font,17,0,VInfo,Nil);
  NGad[18]:=NewGadget(8+dum*4,PubScr^.BarHeight+4+2*Tatter.ta_YSize+NGad[1].ng_Height+8,dum,PubScr^.Font^.ta_YSize+2,'Close',PubScr^.Font,18,0,VInfo,Nil);
  NGad[19]:=NewGadget(8+dum*5,PubScr^.BarHeight+4+2*Tatter.ta_YSize+NGad[1].ng_Height+8,dum,PubScr^.Font^.ta_YSize+2,'Freeze',PubScr^.Font,19,0,VInfo,Nil);
  NGad[20]:=NewGadget(8+dum*6,PubScr^.BarHeight+4+2*Tatter.ta_YSize+NGad[1].ng_Height+8,dum,PubScr^.Font^.ta_YSize+2,'Fenster',PubScr^.Font,20,0,VInfo,Nil);
  NGad[21]:=NewGadget(8+dum*7,PubScr^.BarHeight+4+2*Tatter.ta_YSize+NGad[1].ng_Height+8,dum,PubScr^.Font^.ta_YSize+2,'Zurck',PubScr^.Font,21,0,VInfo,Nil);
  Tags[1]:=TagItem(GTLV_Labels,       Long(^Liste));
  Tags[2].ti_Tag:=TAG_DONE;
  LstGad:=CreateGadgetA(LISTVIEW_KIND,FGad,^NGad[1],^Tags);
  Gad:=CreateGadgetA(BUTTON_KIND,LstGad,^NGad[2],Nil);
  For dum:=3 to 13 Do
    Gad:=CreateGadgetA(BUTTON_KIND,Gad   ,^NGad[dum],Nil);
  Gads[1]:=CreateGadgetA(BUTTON_KIND,Gad   ,^NGad[14],Nil);
  For dum:=2 to 8 Do
    Gads[dum]:=CreateGadgetA(BUTTON_KIND,Gads[dum-1],^NGad[dum+13],Nil);
  MakeGadgets:=Long(FGad);
END;


PROCEDURE InitMenu;

VAR     MenDat  :Array[1..20] of NewMenu;
        Tags    :Array[1..3] of TagItem;

BEGIN
  MenDat[ 1]:=NewMenu(NM_TITLE,'Projekt'        ,Nil,0,0,Nil);
  MenDat[ 2]:=NewMenu(NM_ITEM, 'Iconifizieren'  ,'I',0,0,Nil);
  MenDat[ 3]:=NewMenu(NM_ITEM, 'ber...'        ,'?',0,0,Nil);
  MenDat[ 4]:=NewMenu(NM_ITEM, 'Ende'           ,'Q',0,0,Nil);
  MenDat[ 5]:=NewMenu(NM_TITLE,'Optionen'                ,Nil,0,0,Nil);
  MenDat[ 6]:=NewMenu(NM_ITEM, 'Speicher aufrumen'      ,Nil,0,0,Nil);
  MenDat[ 7]:=NewMenu(NM_ITEM, 'Aktuelle Anzeige drucken',Nil,0,0,Nil);
  MenDat[ 8]:=NewMenu(NM_ITEM, Ptr(NM_BARLABEL)          ,Nil,0,0,Nil);
  MenDat[ 9]:=NewMenu(NM_ITEM, 'Task&Fenster-Relationen' ,Nil,MENUTOGGLE or CHECKIT or (CHECKED*Word(TWinRel)),0,Nil);
  MenDat[10]:=NewMenu(NM_ITEM, 'Sicherheitsabfragen'     ,Nil,MENUTOGGLE or CHECKIT or (CHECKED*Word(Fragen)),0,Nil);
  MenDat[11]:=NewMenu(NM_TITLE,'Struktur'          ,Nil,0,0,Nil);
  MenDat[12]:=NewMenu(NM_ITEM, 'Andere Struktur'   ,'O',0,0,Nil);
  MenDat[13]:=NewMenu(NM_ITEM, 'Node-Strukturen'   ,Nil,0,0,Nil);
  MenDat[14]:=NewMenu(NM_ITEM, Ptr(NM_BARLABEL)    ,Nil,0,0,Nil);
  MenDat[15]:=NewMenu(NM_ITEM, 'Zurck'         ,'B',0,0,Nil);
  If AmigaGuideBase=Nil Then
    MenDat[16]:=NewMenu(NM_END,  Nil               ,Nil,0,0,Nil)
  Else Begin
    MenDat[16]:=NewMenu(NM_TITLE,'Hilfe'           ,Nil,0,0,Nil);
    MenDat[17]:=NewMenu(NM_ITEM, 'Allgemein'       ,'H',0,0,Nil);
    MenDat[18]:=NewMenu(NM_ITEM, 'Kurzbersicht'   ,'K',0,0,Nil);
    If IntuitionBase^.LibNode.lib_Version>38 Then
      MenDat[19]:=NewMenu(NM_ITEM, 'Aktuelle Anzeige','Help',COMMSEQ,0,Nil)
    Else
      MenDat[19]:=NewMenu(NM_ITEM, 'Aktuelle Anzeige',Nil,0,0,Nil);
    MenDat[20]:=NewMenu(NM_END,  Nil               ,Nil,0,0,Nil);
  End;
  Tags[1]:=TagItem(GTMN_NewLookMenus, Long(true));
  Tags[2].ti_Tag:=TAG_DONE;
  Men:=CreateMenusA(^MenDat,Nil);
  If LayoutMenusA(Men,VInfo,^Tags) Then;
  If SetMenuStrip(Win,Men) Then;
END;


PROCEDURE OpenXOpaWindow(Left,Top,Wid,Hei :Integer;DMode :Long);

VAR     Tags    :Array[1..16] of TagItem;
                                                {ffnet das XOpa-Hauptfenster}
BEGIN
  GadList:=Nil;
  If Wid>PubScr^.Width Then
    Wid:=PubScr^.Width;
  If Hei>PubScr^.Height Then
    Hei:=PubScr^.Height;
  WinTitle:='XOpa '+_VERSION+' von Axel Drfler';
  Tags[ 1]:=TagItem(WA_Width,       Wid);
  Tags[ 2]:=TagItem(WA_Height,      Hei);
  Tags[ 3]:=TagItem(WA_IDCMP,       IDCMP_MENUPICK or LISTVIEWIDCMP or IDCMP_RAWKEY or IDCMP_CLOSEWINDOW or IDCMP_NEWSIZE or IDCMP_SIZEVERIFY or IDCMP_MENUHELP);
  Tags[ 4]:=TagItem(WA_Flags,       WFLG_DEPTHGADGET or WFLG_DRAGBAR or WFLG_CLOSEGADGET or WFLG_ACTIVATE or WFLG_SIZEGADGET or WFLG_SIZEBBOTTOM);
  Tags[ 5]:=TagItem(WA_Title,       Long(^WinTitle));
  Tags[ 6]:=TagItem(WA_Gadgets,     MakeGadgets(Tags[1].ti_Data,Tags[2].ti_Data));
  Tags[ 7]:=TagItem(WA_MaxWidth,    PubScr^.Width);
  Tags[ 8]:=TagItem(WA_MinWidth,    504);
  Tags[ 9]:=TagItem(WA_Left,        Left);
  Tags[10]:=TagItem(WA_Top,         Top);
  Tags[11]:=TagItem(WA_MaxHeight,   PubScr^.Height);
  Tags[12]:=TagItem(WA_MinHeight,   PubScr^.BarHeight+3*PubScr^.Font^.ta_YSize+40+5*GfxBase^.DefaultFont^.tf_YSize);
  Tags[13]:=TagItem(WA_NewLookMenus,1);
  Tags[14]:=TagItem(WA_PubScreen,   Long(PubScr));
  Tags[15]:=TagItem(WA_MenuHelp,    1);
  Tags[16].ti_Tag:=TAG_DONE;
  Win:=OpenWindowTagList(Nil, ^Tags);
  If Win=Nil Then
    ErrorRequest('Ciao Mdels!',true);
  GT_RefreshWindow(Win, Nil);
  InitMenu;
  DispMode:=DMode;
  If (DMode<21) and (DMode<>12) Then
    GetList;
  DrawMask;
END;


PROCEDURE CloseAll;

BEGIN
  Dispose(TitleTexts);
  If Win<>Nil Then
    CloseWindow(Win);
  If GadList<>Nil Then
    FreeGadgets(GadList);
  If Men<>Nil Then
    FreeMenus(Men);
  If VInfo<>Nil Then
    FreeVisualInfo(VInfo);
  UnlockPubScreen(Nil,PubScr);
END;


PROCEDURE InitPrefs(VAR x,y,w,h :Integer);

VAR     OldLock :BPTR;
        DiskObj :^DiskObject;
        WBStMsg :^WBStartup;
        TType   :Str;
        i,j     :Integer;
                                                {setzt die XOpa-Voreinstellungen (ber .info)}
BEGIN
  New(TitleTexts);
  {Tasks}     TitleTexts^[ 1]:='Adresse |Pri |Stack|Signale |State  |Code|Typ     |Name';
  {Screens}   TitleTexts^[ 2]:='Adresse |Pos(x,y) |Mae(x,y)|Dep|Modus |Typ   |Titel';
  {Ports}     TitleTexts^[ 3]:='Adresse |Pri |Flags  |SBit|Typ    |Portname          |Taskname';
  {Libraries} TitleTexts^[ 4]:='Adresse |Pri |Version  |OpenC|Neg  |Pos  |Typ     |Name';
  {Resources} TitleTexts^[ 5]:='Adresse |Pri |Version  |OpenC|Neg  |Pos  |Typ     |Name';
  {Devices}   TitleTexts^[ 6]:='Adresse |Pri |Version  |OpenC|Neg  |Pos  |Typ     |Name';
  {System}    TitleTexts^[ 7]:='Informationen ber das System';
  {Interrupts}TitleTexts^[ 8]:='Adresse |Pri |Data    |Code    |Nr |Interrupt |Ctrl|Typ      |Name';
  {Assigns}   TitleTexts^[ 9]:='Adresse   |Assign-Name       |Pfad';
  {Residents} TitleTexts^[10]:='Adresse |Pri |Version|Flags|Typ       |Name';
  {Fonts}     TitleTexts^[11]:='Adresse |Breite|Hhe |BaseLine|LoChar|HiChar|OpenC|CharData|Name';
  {Struktur}  TitleTexts^[12]:='Systemstrukturen-Modus';
  {Info}      TitleTexts^[13]:='Informationen ber das Programm';
  {Fenster}   TitleTexts^[14]:='Adresse |Pos(x,y) |Mae(x,y)|IDCMP   |Flags   |Titel';

  {Tasks}     TitleTexts^[21]:='Task-Informationen';
  {Screens}   TitleTexts^[22]:='Bildschirm-Informationen';
  {Ports}     TitleTexts^[23]:=' ';
  {Libraries} TitleTexts^[24]:=' ';
  {Resources} TitleTexts^[25]:=' ';
  {Devices}   TitleTexts^[26]:=' ';
  {System}    TitleTexts^[27]:=' ';
  {Interrupts}TitleTexts^[28]:=' ';
  {Assigns}   TitleTexts^[29]:=' ';
  {Residents} TitleTexts^[30]:=' ';
  {Fonts}     TitleTexts^[31]:=' ';
  {Fenster}   TitleTexts^[34]:='Fenster-Informationen';
             {Add Remove Signal Pri Close Freeze Fenster Zurck}
                              {ARSPCFFZ}
  {Tasks}     ActiveGads[ 1]:=%01110110;
  {Screens}   ActiveGads[ 2]:=%10001010;
  {Ports}     ActiveGads[ 3]:=%01010000;
  {Libraries} ActiveGads[ 4]:=%01010000;
  {Resources} ActiveGads[ 5]:=%01010000;
  {Devices}   ActiveGads[ 6]:=%01010000;
  {System}    ActiveGads[ 7]:=%00010000;
  {Interrupts}ActiveGads[ 8]:=%01010000;
  {Assigns}   ActiveGads[ 9]:=%11000000;
  {Residents} ActiveGads[10]:=%00000000;
  {Fonts}     ActiveGads[11]:=%10001000;
  {Struktur}  ActiveGads[12]:=%00000001;
  {Info}      ActiveGads[13]:=%00000000;
  {Fenster}   ActiveGads[14]:=%00001010;
  StructName:='XOpa.structs';
  If FromWB Then Begin
    OpenLib(IconBase,'icon.library',0);
    WBStMsg:=StartupMessage;
    OldLock:=CurrentDir(WBStMsg^.sm_ArgList^[1].wa_Lock);
    DiskObj:=GetDiskObject(WBStMsg^.sm_ArgList^[1].wa_Name);
    TWinRel:=false;
    Fragen:=false;
    If DiskObj<>Nil Then Begin
      If Ptr(FindToolType(DiskObj^.do_ToolTypes,'TASKWINDOWS'))<>Nil Then
        TWinRel:=true;
      If Ptr(FindToolType(DiskObj^.do_ToolTypes,'SECURITYCHECK'))<>Nil Then
        Fragen:=true;
      TType:=FindToolType(DiskObj^.do_ToolTypes,'STRUCTS');
      If Ptr(TType)<>Nil Then
        StructName:=TType;
      TType:=FindToolType(DiskObj^.do_ToolTypes,'WINDOW');
      If Ptr(TType)<>Nil Then Begin
        j:=0;
        For i:=1 to Length(TType) Do
          If Copy(TType,i,1)='/' Then
            Inc(j);
        If j=3 Then Begin
          Val(TType,j,i);  TType:=Str(Long(TType)+i);
          If i>1 Then
            x:=j;
          Val(TType,j,i);  TType:=Str(Long(TType)+i);
          If i>1 Then
            y:=j;
          Val(TType,j,i);  TType:=Str(Long(TType)+i);
          If (j>=504) and (i>1) Then
            w:=j;
          If TType<>'' Then Begin
            Val(TType,j,i);
            If (j>PubScr^.BarHeight+3*PubScr^.Font^.ta_YSize+40+5*GfxBase^.DefaultFont^.tf_YSize) Then
              h:=j;
          End;
        End Else
          ErrorRequest('ToolType "WINDOW" falsch benutzt.',false);
      End;
      TType:=FindToolType(DiskObj^.do_ToolTypes,'DISPLAY');
      If Ptr(TType)<>Nil Then Begin
        If MatchToolValue(TType,'TASKS') Then
          DispMode:=1
        Else If MatchToolValue(TType,'SCREENS') Then
          DispMode:=2
        Else If MatchToolValue(TType,'PORTS') Then
          DispMode:=3
        Else If MatchToolValue(TType,'LIBRARIES') Then
          DispMode:=4
        Else If MatchToolValue(TType,'RESOURCES') Then
          DispMode:=5
        Else If MatchToolValue(TType,'DEVICES') Then
          DispMode:=6
        Else If MatchToolValue(TType,'SYSTEM') Then
          DispMode:=7
        Else If MatchToolValue(TType,'INTERRUPTS') Then
          DispMode:=8
        Else If MatchToolValue(TType,'ABOUT') Then
          DispMode:=13
        Else If MatchToolValue(TType,'ASSIGNS') Then
          DispMode:=9
        Else If MatchToolValue(TType,'FONTS') Then
          DispMode:=11
        Else If MatchToolValue(TType,'RESIDENTS') Then
          DispMode:=10;
      End;
      FreeDiskObject(DiskObj);
    End Else Begin
      Fragen:=true;
      TWinRel:=false;
    End;
    CloseLib(IconBase);
  End Else Begin
    Fragen:=true;
    TWinRel:=false;
  End;
END;


PROCEDURE InitSomeStuff;
                                        {wird von "Init" und "IconifyXOpa" aufgerufen}
BEGIN
  PubScr:=LockPubScreen(Nil);
  Tatter:=TextAttr(GfxBase^.DefaultFont^.tf_Message.mn_Node.ln_Name,GfxBase^.DefaultFont^.tf_YSize,0,0);
  TatXSize:=GfxBase^.DefaultFont^.tf_XSize;
  VInfo:=GetVisualInfoA(PubScr, Nil);
END;


PROCEDURE Init;

VAR     x,y,w,h :Integer;
                                        {ruft Init-Prozeduren}
BEGIN
  If GfxBase^.LibNode.lib_Version<36 Then
    Halt(0);
  OpenLib(ExpansionBase,'expansion.library',0);
  OpenLib(AslBase,'asl.library',0);
  AmigaGuideBase:=OpenLibrary('amigaguide.library',0);
  New(SleepReq);  Win:=Nil;  AktStruct:=Nil;
  MPointerDat:=Ptr(Alloc_Mem(SizeOf(MousePointerTyp),MEMF_CHIP));
  MPointerDat^:=MousePointerTyp($00000000,$040007c0,$000007c0,$01000380,$000007e0,
                                $07c01ff8,$1ff03fec,$3ff87fde,$3ff87fbe,$7ffcff7f,
                                $7efcffff,$7ffcffff,$3ff87ffe,$3ff87ffe,$1ff03ffc,
                                $07c01ff8,$000007e0,$00000000);   {<- Standard OS2.0 Mauszeiger}
  AddExitServer(CloseAll);
  InitSomeStuff;
  DispMode:=13;  StructAddress:=Nil;
  If (PubScr=Nil) or (PubScr^.Width<504) Then
    ErrorRequest('ffentlicher Bildschirm zu schmal.',true);
  x:=0;  y:=PubScr^.BarHeight+1;
  w:=640;  h:=PubScr^.BarHeight+3*PubScr^.Font^.ta_YSize+40+Tatter.ta_YSize*17;
  InitPrefs(x,y,w,h);
  NewList(^Liste);  NewList(^Structs);  NewList(^Libraries);  NewList(^MerkListe);
  OpenXOpaWindow(x,y,w,h,DispMode);
END;


PROCEDURE IconifyXOpa;

VAR     DiskObj         :DiskObject;
        WBStMsg         :^WBStartup;
        myPort          :^MsgPort;
        myAppIcon       :^AppIcon;
        AppMsg          :^AppMessage;
        AppImg          :Image;
        iconifyImage    :Word;  IMPORT;
        winHeight,winY  :Long;
        winWidth,winX   :Long;
        ok              :Boolean;

BEGIN
  If Win=Nil Then
    Exit;
  GT_ReplyIMsg(Msg);
  Msg:=Nil;
  winX:=Win^.LeftEdge;
  winY:=Win^.TopEdge;
  winWidth:=Win^.Width;
  winHeight:=Win^.Height;
  CloseWindow(Win);
  FreeGadgets(GadList);
  FreeMenus(Men);
  OpenLib(IconBase,'icon.library',0);
  OpenLib(WorkbenchBase,'workbench.library',0);
  WBStMsg:=StartupMessage;
  myPort:=Nil;
  myAppIcon:=Nil;
  AppImg:=Image(0,0,44,40,2,^iconifyImage,3,0,Nil);
  DiskObj:=DiskObject(WB_DISKMAGIC,WB_DISKVERSION,Gadget(Nil,97,12,44,41,GADGIMAGE+GADGHBOX,GADGIMMEDIATE+RELVERIFY,BOOLGADGET,^AppImg,Nil,Nil,0,Nil,0,Nil),0,Nil,Nil,$80000000,$80000000,Nil,Nil,4096);
  myPort:=CreateMsgPort;
  If myPort<>Nil Then Begin
    myAppIcon:=AddAppIconA(0,0,'XOpa',myPort,Nil,^DiskObj,Nil);
    If myAppIcon<>Nil Then Begin
      If VInfo<>Nil Then
        FreeVisualInfo(VInfo);
      UnlockPubScreen(Nil,PubScr);
      ok:=false;
      Repeat
        AppMsg:=Wait_Port(myPort);
        AppMsg:=Get_Msg(myPort);
        While AppMsg<>Nil Do Begin
          If AppMsg^.am_NumArgs=0 Then
            ok:=true;
          Reply_Msg(^AppMsg^);
          AppMsg:=Get_Msg(myPort);
        End;
      Until ok;
      If RemoveAppIcon(myAppIcon) Then;
      InitSomeStuff;
    End;
    DeleteMsgPort(myPort);
  End;
  CloseLib(IconBase);
  CloseLib(WorkbenchBase);
  OpenXOpaWindow(winX,winY,winWidth,winHeight,DispMode);
END;


PROCEDURE HandleToolGadgets(GadNum :Long);

VAR     Tags    :Array[1..3] of TagItem;

BEGIN
  Tags[1]:=TagItem(GTLV_Labels, Long(Not 0));
  Tags[2].ti_Tag:=TAG_DONE;
  GT_SetGadgetAttrsA(LstGad, Win, Nil, ^Tags);
  GadNum:=GadNum-13;
  If DispMode=1 Then
    WinTask:=AktNode^.Address;
  If DispMode=2 Then
    ScrPtr:=AktNode^.Address;
  Case DispMode Of
     1: TaskTools(GadNum);
     2: ScrTools(GadNum);
     3: PortTools(GadNum);
     4..6: LibsTools(GadNum);
     7: SysTools(GadNum);
     8: IntrTools(GadNum);
     9: AssignTools(GadNum);
    11: FontTools(GadNum);
    14: WinTools(GadNum);
    21: TaskTools(GadNum);
    22: ScrTools(GadNum);
  Else;
  End;
  If (AktNode=Nil) or (DispMode=14) Then
    GetList;
  Tags[1]:=TagItem(GTLV_Labels, Long(^Liste));
  Tags[2].ti_Tag:=TAG_DONE;
  GT_SetGadgetAttrsA(LstGad, Win, Nil, ^Tags);
END;


PROCEDURE FreeLastMerker;

VAR     Merk    :^Merker;

BEGIN
  If(MerkListe.lh_Head<>^MerkListe.lh_Tail) Then Begin
    Merk:=p_Merker(MerkListe.lh_TailPred);
    Remove(^Merk^);  Dispose(Merk);
  End;
END;


PROCEDURE GetLastStructure;

VAR     Merk    :^Merker;
        Tags    :Array[1..2] of TagItem;
                                                {ruft die letzte Struktur auf (Zurck-Gadget)}
BEGIN
  If (DispMode=12) and (MerkListe.lh_Head<>^MerkListe.lh_Tail) Then Begin
    FreeNodeList;
    Merk:=p_Merker(MerkListe.lh_TailPred);
    SetWaitPointer(true);
    If Merk^.Struct<>Ptr($ffffffff) Then
      GetStructure(Merk^.Address,Merk^.Struct^.Name)
    Else
      GetMemView(Merk^.Address);
    Tags[1]:=TagItem(GTLV_Top, Merk^.Top);
  Tags[2].ti_Tag:=TAG_DONE;
    Remove(^Merk^);  Dispose(Merk);
    FreeLastMerker;
    DrawMask;
    GT_SetGadgetAttrsA(LstGad, Win, Nil, ^Tags);
    SetWaitPointer(false);
  End;
END;


PROCEDURE HandleGadgets;

VAR     AktGad  :^Gadget;
        Tags    :Array[1..3] of TagItem;
        Txt     :AppString;
        IText   :IntuiText;
        OldNum  :Long;  STATIC;
        OldSec  :Long;  STATIC;
        OldMSec :Long;  STATIC;
        NewSec  :Long;
        NewMSec :Long;

BEGIN
  AktGad:=Msg^.IAddress;
  Case AktGad^.GadgetID Of
    1: Begin
         dum:=0;
         AktNode:=p_ListEntry(Liste.lh_Head);
         While dum<Msg^.Code Do Begin
           Inc(dum);
           AktNode:=p_ListEntry(AktNode^.Node.ln_Succ);
         End;
         SetAPen(Win^.RPort, 0);
         StatusText:=AktNode^.ObjName;
         If DispMode<>12 Then
           DrawStatus;
         If oldNum=dum Then Begin
           CurrentTime(^NewSec,^NewMSec);
           If (DoubleClick(OldSec,OldMSec,NewSec,NewMSec)) Then
             GetMoreInfos;
           OldSec:=0;
           OldNum:=-42;
         End Else Begin
           CurrentTime(^OldSec,^OldMSec);
           OldNum:=dum;
         End;
       End;
    2..13: Begin
             DispMode:=AktGad^.GadgetID-1;
             Tags[1]:=TagItem(GTLV_Labels, Long(Not 0));
             Tags[2].ti_Tag:=TAG_DONE;
             GT_SetGadgetAttrsA(LstGad, Win, Nil, ^Tags);
             GetList;
             AktNode:=Nil;
             DrawMask;
           End;
    14: HandleToolGadgets(AktGad^.GadgetID);
    15..20: If (AktNode<>Nil) or (DispMode=11) and (AktGad^.GadgetID=18) or (DispMode=14) and (AktGad^.GadgetID=20) or (DispMode=22) or (DispMode=21) Then
              HandleToolGadgets(AktGad^.GadgetID);
    21: If DispMode=12 Then
          GetLastStructure
        Else Begin
          DispMode:=14;
          GetList;
        End;
  Else;
  End;
END;


PROCEDURE HandleMenuHelp;

BEGIN
  dum:=0;
  Case _MenuNum(Msg^.Code) Of
    0: Case _ItemNum(Msg^.Code) Of
         NOITEM: dum:=11;
         0: dum:=13;
         1: dum:=23;
         2: dum:=28;
       Else;
       End;
    1: Case _ItemNum(Msg^.Code) Of
         NOITEM: dum:=34;
         0: dum:=36;
         1: dum:=42;
         3: dum:=46;
         4: dum:=59;
       Else;
       End;
    2: Case _ItemNum(Msg^.Code) Of
         NOITEM: dum:=66;
         0: dum:=68;
         1: dum:=73;
         3: dum:=78;
       Else;
       End;
    3: dum:=88;
  Else;
  End;
  ShowGuide('Menus',dum);
END;


PROCEDURE HandleMenu;

VAR     myStruct:^Struct;
        AktPtr  :Ptr;

BEGIN
  Case _MenuNum(Msg^.Code) Of
    0: Case _ItemNum(Msg^.Code) Of
         0: IconifyXOpa;
         1: Begin
              DispMode:=13;
              GetList;
              DrawMask;
            End;
         2: Ende:=true;
       Else;
       End;
    1: Case _ItemNum(Msg^.Code) Of
         0: Begin
              FlushLibraries;
              SetWaitPointer(true);
              Delay(50);
              If (DispMode<20) and (DispMode<>12) Then
                GetList
              Else
                SetWaitPointer(false);
            End;
         1: Begin
              SetWaitPointer(true);
              ListeDrucken;
              SetWaitPointer(false);
            End;
         3: TWinRel:=Not TWinRel;
         4: Fragen:=Not Fragen;
       Else;
       End;
    2: If _ItemNum(Msg^.Code)=1 Then Begin
         SetWaitPointer(true);
         NodeStruktur;
         If (DispMode=12) and (AktStruct<>Nil) Then Begin
           FreeNodeList;  StatusText:='';
           If AktStruct<>Ptr($ffffffff) Then
             GetStructure(StructAddress,AktStruct^.Name)
           Else
             GetMemView(StructAddress);
           FreeLastMerker;
           DrawMask;
           AktNode:=Nil;
         End;
         SetWaitPointer(false);
       End Else If DispMode<>12 Then Begin
         ErrorRequest('Nur im Struktur-Modus sinnvoll.',false);
       End Else If StructAddress=Nil Then Begin
         ErrorRequest('Aktuelle Strukturadresse ungltig.',false);
       End Else Begin
         Case _ItemNum(Msg^.Code) Of
           0: Begin
                SetWaitPointer(true);
                AktPtr:=StructAddress;
                myStruct:=AndereStruktur(AktPtr);
                If myStruct<>Nil Then Begin
                  FreeNodeList;
                  StatusText:='';
                  If myStruct<>Ptr($ffffffff) Then
                    GetStructure(AktPtr,myStruct^.Name)
                  Else
                    GetMemView(AktPtr);
                  DrawMask;
                  AktNode:=Nil;
                End;
                SetWaitPointer(false);
              End;
           3: GetLastStructure;
         Else;
         End;
       End;
    3: Case _ItemNum(Msg^.Code) Of
         0: ShowGuide('MAIN',0);
         1: ShowGuide('kurz',0);
         2: ShowGuide('',0);
       Else;
       End;
  Else;
  End;
END;


PROCEDURE HandleIDCMP;

VAR     Tags    :Array[1..4] of TagItem;

BEGIN
  Case Msg^.Class Of
    IDCMP_CLOSEWINDOW: Ende:=true;
    IDCMP_RAWKEY: If Msg^.Code=223 Then ShowGuide('',0);
    IDCMP_GADGETUP: HandleGadgets;
    IDCMP_SIZEVERIFY: Begin
                        dum:=RemoveGList(Win, GadList, CountGadToolGads);
                        FreeGadgets(GadList);
                        GadList:=Nil;
                      End;
    IDCMP_NEWSIZE: Begin
                     SetAPen(Win^.RPort,0);
                     RectFill(Win^.RPort, Win^.BorderLeft,Win^.BorderTop,Win^.Width-Win^.BorderRight-1,Win^.Height-Win^.BorderBottom-1);
                     dum:=AddGList(^Win^,Ptr(MakeGadgets(Win^.Width,Win^.Height)),0,-1,Nil);
                     RefreshGadgets(Win^.FirstGadget, Win, Nil);
                     GT_RefreshWindow(Win, Nil);
                     If DispMode=13 Then Begin
                       Tags[1]:=TagItem(GTLV_Labels, Long(Not 0));
                       Tags[2].ti_Tag:=TAG_DONE;
                       GT_SetGadgetAttrsA(LstGad, Win, Nil, ^Tags);
                       GetList;
                       AktNode:=Nil;
                     End;
                     DrawMask;
                   End;
    IDCMP_MENUPICK: HandleMenu;
    IDCMP_MENUHELP: HandleMenuHelp;
  Else;
  End;
END;



BEGIN
  Init;

  Ende:=false;
  Repeat
    Msg:=Wait_Port(Win^.UserPort);        {Hauptschleife}
    Msg:=GT_GetIMsg(Win^.UserPort);
    HandleIDCMP;
    If Msg<>Nil Then
      GT_ReplyIMsg(Msg);
  Until Ende;
END.

{$ulink "asm/XOpa_IconifyImage.o","asm/XOpa_Dez2Hex.o"}

